'From Squeak 2.4 of April 21, 1999 on 22 April 1999 at 6:39:30 pm'!
"Change Set:		boolScriptorFix-sw
Date:			22 April 1999
Author:			Scott Wallace

Fixes an error that occurred when a naked text/yes/no scripting complex resides in a world and one is attempting to update scriptors.  What does this mean?  Never mind!!"!


!ScriptEditorMorph methodsFor: 'initialization' stamp: 'sw 4/22/1999 18:33'!
bringUpToDate
	"Make certain that the script name and the names of actors within are up to date"

	| currentName titleMorph newName |
	playerScripted ifNil: ["likely a naked test/yes/no fragment!!" ^ self].

	currentName _ playerScripted externalName.
	titleMorph _ self findDeepSubmorphThat: [:m | m externalName = 'title'] ifAbsent: [nil].
	titleMorph ifNotNil:
		[newName _ self isAnonymous
			ifTrue:
				['script']
			ifFalse:
				[self scriptName].
		titleMorph label: currentName, ' ', newName font: ScriptingSystem fontForTiles]! !


