'From Squeak 2.4b of April 23, 1999 on 10 May 1999 at 3:53:21 pm'!
"Change Set:		MVCpreference
Date:			10 May 1999
Author:			Dan Ingalls

Disable access to MVC projects when MVC not present or when preference is disabled.
"!


!HandMorph methodsFor: 'world menu' stamp: 'di 5/10/1999 15:49'!
openMenu
	"Build the open window menu for the world."
	| menu |
	menu _ (MenuMorph entitled: 'open...') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'browser' action: #openBrowser.
	menu add: 'workspace' action: #openWorkspace.
	menu add: 'file list' action: #openFileList.
	menu add: 'transcript' target: Transcript action: #open.
	menu add: 'selector finder' target: ScreenController new action: #openSelectorBrowser.
	menu addLine.
	menu add: 'simple change sorter' selector: #openChangeSorter: argument: 1.
	menu add: 'dual change sorter' selector: #openChangeSorter: argument: 2.
	menu addLine.
	menu add: 'email reader' action: #openEmail.
	menu add: 'web browser' action: #openWebBrowser.
	menu add: 'IRC chat' action: #openIRC.
	menu addLine.
	(Preferences allowMVCprojects and: [Smalltalk includesKey: #StandardSystemView])
		ifTrue: [menu add: 'project (mvc)' action: #openMVCProject].
	menu add: 'project (morphic)' action: #openMorphicProject.
	menu add: 'project (construction)' action: #openConstructionProject.
	^ menu
! !


"Postscript:
As a default continue to allow creation of MVC projects."

Preferences enable: #allowMVCprojects.!

