'From Squeak 2.4b of April 23, 1999 on 29 June 1999 at 12:06:43 am'!
"Change Set:		Alice2Pool
Date:			29 June 1999
Author:			Jeff Pierce

Define the pool dictionary for Alice v2.0."!

Object subclass: #AlicePoolDefiner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alice2.0-Misc'!

!AlicePoolDefiner class methodsFor: 'class initialization' stamp: 'jsp 6/7/1999 14:58'!
initialize
	"Initialize the Alice 2.0 pool dictionary"

	self initPool.
! !

!AlicePoolDefiner class methodsFor: 'pool definition' stamp: 'jsp 6/29/1999 00:06'!
initPool
	"Create the pool dictionary if necessary"

	| poolName |
	poolName _ #AliceConstants.
	(Smalltalk includesKey: poolName) ifFalse:[
		Smalltalk declare: poolName from: Undeclared.
	].

	(Smalltalk at: poolName) isNil ifTrue:[
		(Smalltalk associationAt: poolName)
				value: ((Smalltalk at: #WonderlandConstants) copy).
	].

	self initPool: (Smalltalk at: poolName).! !

!AlicePoolDefiner class methodsFor: 'pool definition' stamp: 'jsp 6/7/1999 15:03'!
initPool: aDictionary
	"Initialize the dictionary"

	aDictionary at: #inOrder put: #inOrder.
	aDictionary at: #together put: #together.
! !


AlicePoolDefiner initialize!
