'From Squeak 2.5 of August 6, 1999 [latest update: #1548] on 15 October 1999 at 4:07:40 pm'!

!ImageSegment class methodsFor: 'fileIn/Out' stamp: 'di 10/15/1999 16:07'!
reclaimObsoleteSegmentFiles  "ImageSegment reclaimObsoleteSegmentFiles"
	"Delete segment files that can't be used after this image is saved.
	Note that this is never necessary -- it just saves file space."

	| segDir segFiles folderName |
	folderName _ FileDirectory default class localNameFor: self folder.
	(FileDirectory default includesKey: folderName) ifFalse: [^ self "don't create if absent"].

	segDir _ self segmentDirectory.
	segFiles _ (segDir fileNames select: [:fn | fn endsWith: '.seg']) asSet.
	segFiles isEmpty ifTrue: [^ self].
	ImageSegment allInstancesDo: [:is | 
		is isOnFile ifTrue: [
			segFiles remove: is localName ifAbsent: [
				Transcript cr; show: 'Segment file not found: ', is localName].
			segFiles do: [:fName | 
				fName sansPeriodSuffix stemAndNumericSuffix first = is segmentName 
					ifTrue: [segDir deleteFileNamed: fName]]]].! !
