'From Squeak 2.1 of June 30, 1998 on 8 August 1998 at 9:49:33 am'!
"Change Set:		MMenuOverlapFix
Date:			8 August 1998
Author:			Bob Arning <arning@charm.net>

Causes subMenu items to appear on the left when there is no room on the right"!


!MenuItemMorph methodsFor: 'private' stamp: 'di 8/8/1998 09:22'!
selectFromHand: aHand

	self isSelected: true.
	aHand newMouseFocus: self.
	subMenu ifNotNil: [
		subMenu delete.
		subMenu
			popUpAdjacentTo: (Array with: self bounds topRight + (10@0)
									with: self bounds topLeft)
			forHand: aHand
			from: self].
! !


!MenuMorph methodsFor: 'control' stamp: 'di 8/8/1998 09:48'!
popUpAdjacentTo: rightOrLeftPoint forHand: hand from: sourceItem
	"Present this menu at the given point under control of the given hand."

	| selectedItem delta tryToPlace selectedOffset |

	popUpOwner _ sourceItem.
	originalEvent _ MorphicEvent new setHand: hand.
	selectedItem _ self items detect: [:each | each == lastSelection]
							ifNone: [self items first].
	self fullBounds.  "ensure layout is current"
	selectedOffset := selectedItem position - self position.
	tryToPlace :=
		[ :where :mustFit |
		self position: where - selectedOffset.
		delta _ self fullBoundsInWorld amountToTranslateWithin: hand worldBounds.
		(delta x = 0 or: [mustFit]) ifTrue:
			[delta = (0@0) ifFalse: [self position: self position + delta].
			sourceItem owner owner addMorphFront: self.
			^ self]].
	tryToPlace 
		value: rightOrLeftPoint first value: false;
		value: rightOrLeftPoint last  - (self width @ 0) value: false;
		value: rightOrLeftPoint first value: true

	! !


