'From Squeak 2.1 of June 30, 1998 on 13 August 1998 at 10:19:24 am'!
"Change Set:		DeleteTweaks-di
Date:			13 August 1998
Author:			Dan Ingalls

Simplifies morph deletion when no player model is involved.
Also nils out the owner pointer of inactive scroll bars."!


!Morph methodsFor: 'submorphs-add/remove' stamp: 'di 8/13/1998 10:09'!
delete
	"Remove the receiver as a submorph of its owner and make its new owner be nil."
	| aWorld |
	owner ifNotNil:
		[(extension == nil or: [self player == nil])
		ifTrue: [owner privateRemoveMorph: self.
				owner _ nil]
		ifFalse: ["Player must be notified"
				aWorld _ self world.
				owner privateRemoveMorph: self.
				owner _ nil.
				self player noteDeletionOf: self fromWorld: aWorld]
		].! !


!ScrollPane methodsFor: 'retractable scroll bar' stamp: 'di 8/13/1998 10:14'!
mouseLeave: event
	retractableScrollBar ifTrue:
		[self privateRemoveMorph: scrollBar.
		scrollBar privateOwner: nil]! !


