'From Squeak2.8alpha of 12 January 2000 [latest update: #1993] on 11 April 2000 at 4:18:40 pm'!
"Change Set:		SymbolEquals
Date:			11 April 2000
Author:			Dan Ingalls

Changes the definition of Symbol = to string comparison for non-symbol arguments.  This suggestion by Stephan Rudlof establishes the following symmetric properties:

     #abc = 'abc'
     'abc' = #abc
are both true; and
     #abc == 'abc'
     'abc' == #abc
are both false.

The result of = and == between two symbols remains unchanged.
"!


!Symbol methodsFor: 'comparing' stamp: 'di 4/11/2000 16:18'!
= another

	"Use == between two symbols..."
	self == another ifTrue: [^ true].  "Was == "
	another class == Symbol ifTrue: [^ false].  "Was not == "

	"Otherwise use string =..."
	^ super = another! !

