'From Squeak2.8alpha of 19 January 2000 [latest update: #1974] on 21 April 2000 at 2:10:23 pm'!

!PWS class methodsFor: 'Serving' stamp: 'mjg 4/21/2000 14:07'!
serve: aSocket
	"Respond to a request arriving on the given socket and return a string to be entered in the log file."

    | inst reportMsg |
     inst _ self new.
     [inst initializeFrom: aSocket.
     inst getReply]
         ifError: [:msg :rec |  "Fix by Mark Schwenk to deal with Exceptions"
	    reportMsg _ (msg size >= 8 and: [(msg copyFrom: 1 to: 7) = 'Error: '])
                ifTrue: [msg copyFrom: 8 to: msg size]
                ifFalse: [msg].
            inst report: reportMsg for: rec].            
     aSocket closeAndDestroy: 30.
     ^ inst log contents

! !


!ServerAction methodsFor: 'URL processing' stamp: 'mjg 4/21/2000 14:10'!
replyTo: pieces from: request

	"Transcript show: 'Reply: ', pieces; cr."
	(StandardFileStream isAFileNamed: pieces) 
		ifTrue: [
			request reply: PWS success; 
				reply: (PWS content: (MIMEDocument guessTypeFromName: pieces)),
					 PWS crlf.
			request reply: (FileStream fileNamed: pieces) contentsOfEntireFile]
		ifFalse: [
			request error: PWS notFound].
! !


