'From Squeak 2.1 of June 30, 1998 on 21 August 1998 at 11:07:28 am'!
"Change Set:		FileInTweak-di
Date:			21 August 1998
Author:			Dan Ingalls

Do not issue confirmation requests to the user regarding first use of test emphasis during fileIns.  Do continue to do so from the browser if preferences are so set.
"!


!ClassDescription methodsFor: 'compiling' stamp: 'di 8/21/1998 11:01'!
compile: text classified: category withStamp: changeStamp notifying: requestor 
	| selector priorMethod method methodNode newText |
	method _ self
		compile: text asString
		notifying: requestor
		trailer: #(0 0 0 0)
		ifFail: [^nil]
		elseSetSelectorAndNode: 
			[:sel :node | selector _ sel.
			priorMethod _ methodDict at: selector ifAbsent: [nil].
			methodNode _ node].
	self acceptsLoggingOfCompilation ifTrue:
		[newText _ ((requestor == nil or: [requestor isKindOf: SyntaxError]) not
						and: [Preferences confirmFirstUseOfStyle])
			ifTrue: [text askIfAddStyle: priorMethod req: requestor]
			ifFalse: [text].
		 method putSource: newText
				fromParseNode: methodNode
				class: self category: category withStamp: changeStamp 
				inFile: 2 priorMethod: priorMethod].
	self organization classify: selector under: category.
	^selector! !


