'From Squeak2.9alpha of 17 July 2000 [latest update: #2549] on 31 August 2000 at 3:00:45 pm'!
"Change Set:		betterEmbed
Date:			31 August 2000
Author:			Bob Arning

- In certain cases HandMorph may not have an absolutely up-to-date menuTargetOffset (after a green dupe/drag, e.g.). HandMorph>>potentialEmbeddingTargets is enhanced to deal with that, but there may be other places this is also important."!


!HandMorph methodsFor: 'world menu commands' stamp: 'RAA 8/31/2000 14:54'!
potentialEmbeddingTargets
	"Answer a list of targets into which the hand's arguement could be embedded"

	| possibleTargets partsOfArgument where |

	where _ menuTargetOffset.
	partsOfArgument _ #().
	argument ifNotNil: [
		partsOfArgument _ argument allMorphs.
		(argument bounds containsPoint: menuTargetOffset) ifFalse: [
			where _ argument bounds center
		].
	].
	possibleTargets _ self world morphsAt: where.
	possibleTargets removeAllFoundIn: partsOfArgument.
	^ possibleTargets! !

