'From Squeak2.9alpha of 13 June 2000 [latest update: #2725] on 26 September 2000 at 9:35:45 pm'!
"Change Set:		ModalPickerFix-ar
Date:			26 September 2000
Author:			Andreas Raab

Fixes a modal color picker problem. The hard way."!


!ColorPickerMorph methodsFor: 'menu' stamp: 'ar 9/26/2000 21:33'!
pickUpColorFor: aMorph
	"Show the eyedropper cursor, and modally track the mouse through a mouse-down and mouse-up cycle"

      | aCursor aHand |
	aCursor _ ScriptingSystem formAtKey: #Eyedropper.
	aHand _ aMorph ifNil: [self activeHand] ifNotNil: [aMorph activeHand].
	aHand ifNil: [aHand _ self currentHand].
	aHand
		showTemporaryCursor: aCursor 
		hotSpotOffset: 6 negated @ 4 negated.    "<<<< the form was changed a bit??"

	self addToWorld: aHand world near: (aMorph ifNil: [aHand world]) fullBounds.
	self updateContinuously: false.
	[Sensor anyButtonPressed]
		whileFalse: 
			 [self trackColorUnderMouse].

	self updateContinuously: true.
	[Sensor anyButtonPressed]
		whileTrue:
			 [self updateTargetColorWith: self indicateColorUnderMouse].
	self activeHand newMouseFocus: nil.
	self activeHand showTemporaryCursor: nil.
	Sensor flushEvents.
	self delete.
		 
 ! !


!InputSensor methodsFor: 'initialize' stamp: 'ar 9/26/2000 21:35'!
flushEvents
	"Do nothing"! !


!EventSensor methodsFor: 'accessing' stamp: 'ar 9/26/2000 21:33'!
flushEvents
	eventQueue ifNotNil:[eventQueue _ SharedQueue new].! !

