'From Squeak2.9alpha of 13 June 2000 [latest update: #2836] on 9 October 2000 at 5:59:12 pm'!
"Change Set:		ConfusedButtons-ar
Date:			9 October 2000
Author:			Andreas Raab

The last CS had a little confusion with computing the right set of changed buttons."!


!HandMorph methodsFor: 'private events' stamp: 'ar 10/9/2000 17:54'!
generateMouseEvent: evtBuf
	"Generate the appropriate mouse event for the given raw event buffer"
	| position buttons modifiers type trail stamp oldButtons |
	stamp _ (evtBuf at: 2).
	stamp = 0 ifTrue:[stamp _ Time millisecondClockValue].
	position _ (evtBuf at: 3) @ (evtBuf at: 4).
	buttons _ (evtBuf at: 5).
	modifiers _ (evtBuf at: 6).
	buttons = 0 
		ifTrue:[	(lastEventBuffer at: 5) = 0
					ifTrue:[type _ #mouseMove]
					ifFalse:[type _ #mouseUp]]
		ifFalse:[	(lastEventBuffer at: 5) = 0
					ifTrue:[type _ #mouseDown]
					ifFalse:[type _ #mouseMove]].
	buttons _ buttons bitOr: (modifiers bitShift: 3).
	oldButtons _ (lastEventBuffer at: 5) bitOr: ((lastEventBuffer at: 6) bitShift: 3).
	lastEventBuffer _ evtBuf.
	type == #mouseMove ifTrue:[
		trail _ self mouseTrailFrom: evtBuf.
		^MouseMoveEvent new 
			setType: type 
			startPoint: trail first
			endPoint: trail last 
			trail: trail
			buttons: buttons
			hand: self
			stamp: stamp.
	].
	^MouseButtonEvent new 
		setType: type 
		position: position
		which: (oldButtons bitXor: buttons)
		buttons: buttons 
		hand: self
		stamp: stamp! !

