'From Squeak2.9alpha of 13 June 2000 [latest update: #2863] on 11 October 2000 at 5:36:17 pm'!
"Change Set:		PrimErrorFix-ar
Date:			11 October 2000
Author:			Andreas Raab

Make sure the emergency evaluator will act correctly by removing the event queue from Sensor in this very case"!


!Object methodsFor: 'private' stamp: 'ar 10/11/2000 17:34'!
primitiveError: aString 
	"This method is called when the error handling results in a recursion in 
	calling on error: or halt or halt:."

	| context |
	Sensor eventQueue: nil. "Or else we won't get keyboard and possibly run out of memory"
	(String
		streamContents: 
			[:s |
			s nextPutAll: '**System error handling failed**'.
			s cr; nextPutAll: aString.
			context _ thisContext sender sender.
			20 timesRepeat: [context == nil ifFalse: [s cr; print: (context _ context sender)]].
			s cr; nextPutAll: '**Type CR to enter an emergency evaluator.**'.
			s cr; nextPutAll: '**Type any other character to restart.**'])
		displayAt: 0 @ 0.
	[Sensor keyboardPressed] whileFalse.
	Sensor keyboard == Character cr ifTrue: [Transcripter emergencyEvaluator].
	Smalltalk isMorphic ifTrue: [
		^Display reinstallMorphicWorldAfterError "To init hand events and redisplay world"
	].
	ScheduledControllers searchForActiveController! !


!InputSensor methodsFor: 'accessing' stamp: 'ar 10/11/2000 17:34'!
eventQueue
	^nil! !

!InputSensor methodsFor: 'accessing' stamp: 'ar 10/11/2000 17:35'!
eventQueue: aSharedQueue
! !

