'From Squeak2.9alpha of 13 June 2000 [latest update: #2988] on 27 November 2000 at 10:05:45 am'!
"Change Set:		DoubleInitializationFix
Date:			27 November 2000
Author:			Luciano

Fix a double initialization problem in KlattVoice and Speaker."!


!Speaker methodsFor: 'initialization' stamp: 'len 11/27/2000 09:59'!
initialize
	self pitch: 100.0; range: 0.3; loudness: 1.0; speed: 0.6; "normalizer: TextNormalizer new;" transcriber: PhoneticTranscriber default; visitors: {IntonationVisitor default. DurationsVisitor default. F0RenderingVisitor default}! !


!Speaker class methodsFor: 'examples' stamp: 'len 11/27/2000 10:01'!
default
	"
	Speaker default say: 'This is the default voice.'
	"

	^ self new voice: KlattVoice new! !

!Speaker class methodsFor: 'examples' stamp: 'len 11/27/2000 10:01'!
man
	"
	Speaker man say: 'Listen to my voice. I am a man speaking.'
	"

	^ self default pitch: 90.0! !

KlattVoice class removeSelector: #new!
