'From Squeak3.1alpha of 7 February 2001 [latest update: #3619] on 16 February 2001 at 4:32:14 pm'!
"Change Set:		fullCopyAftermath-sw
Date:			16 February 2001
Author:			Scott Wallace

Minor follow-on to the nixFullCopy:
- Put in a backstop fullCopy which forwards to veryDeepCopy.
- Fixes addProjectNavigationButtonsTo:, whose buttons were mildly wrong after the nexFullCopy changes"!


!Morph methodsFor: 'copying' stamp: 'sw 2/16/2001 16:30'!
fullCopy
	"Deprecated, but maintained for backward compatibility with existing code (no senders in the base 3.0 image).   Calls are revectored to #veryDeepCopy, but note that #veryDeepCopy does not do exactly the same thing that the original #fullCopy did, so beware!!"

	^ self veryDeepCopy! !


!Utilities class methodsFor: 'flaps' stamp: 'sw 2/16/2001 15:43'!
addProjectNavigationButtonsTo: aMorph
	"Add prev, next, and go-to buttons at the top of aMorph"

	| aButton aFont bb |
	bb _ SimpleButtonMorph new target: Project.
	bb actionSelector: #returnToPreviousProject.
	bb beTransparent.
	aFont _ StrikeFont familyName: #ComicBold size: 24.

	aButton _ bb copy.
	aButton label: '<' font: aFont; borderWidth: 0.
	aButton firstSubmorph color: Color red lighter.
	aButton position: 30 @ 12.
	aButton setBalloonText: 'previous project'.
	aMorph addMorph: aButton.

	aButton _ bb copy.
	aButton actionSelector: #advanceToNextProject.
	aButton label: '>' font: aFont; borderWidth: 0.
	aButton firstSubmorph color: Color red lighter.
	aButton position: 150 @ 14.
	aButton setBalloonText: 'next project'.
	aMorph addMorph: aButton.

	aButton _ bb copy actWhen: #buttonDown.
	aButton actionSelector: #jumpToProject; target: Project.
	aButton label: 'Go...' font: (StrikeFont familyName: #ComicBold size: 19); borderWidth: 0.
	aButton position: 78 @ 16.
	aButton firstSubmorph color: Color red lighter.
	aButton setBalloonText: 'go directly to a project'.
	aMorph addMorph: aButton! !

