'From Squeak3.1alpha of 5 February 2001 [latest update: #3792] on 5 March 2001 at 9:33:15 pm'!
"Change Set:		skipAProject
Date:			5 March 2001
Author:			Bob Arning

a few more navigational aids for InternalThreadNavigationMorph"!


!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 3/5/2001 21:27'!
destroyThread

	(self confirm: 'Destroy thread <',threadName,'> ?') ifFalse: [^self].
	self class knownThreads removeKey: threadName ifAbsent: [].
	self delete! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 3/5/2001 21:29'!
jumpWithinThread

	| aMenu me weHaveOthers myIndex |

	me _ CurrentProjectRefactoring currentProjectName.
	aMenu _ MenuMorph new defaultTarget: self.
	weHaveOthers _ false.
	myIndex _ self currentIndex.
	listOfPages withIndexDo: [ :each :index |
		index = myIndex ifTrue: [
			aMenu add: 'you are here' action: #yourself.
			aMenu lastSubmorph color: Color red.
		] ifFalse: [
			weHaveOthers _ true.
			aMenu add: 'jump to <',each first,'>' selector: #jumpToIndex: argument: index.
			myIndex = (index - 1) ifTrue: [
				aMenu lastSubmorph color: Color blue
			].
			myIndex = (index + 1) ifTrue: [
				aMenu lastSubmorph color: Color orange
			].
		].
	].
	weHaveOthers ifFalse: [^self inform: 'This is the only project in this thread'].
	aMenu popUpEvent: self world primaryHand lastEvent in: self world! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 3/5/2001 21:24'!
moreCommands

	| allThreads aMenu others target |

	allThreads _ self class knownThreads.
	aMenu _ MenuMorph new defaultTarget: self.
	others _ (allThreads keys reject: [ :each | each = threadName]) asSortedCollection.
	others do: [ :each |
		aMenu add: 'switch to <',each,'>' selector: #switchToThread: argument: each.
	].
	aMenu 
		add: 'switch to recent projects' action: #getRecentThread;
		addLine;
		add: 'thread of all projects' action: #threadOfAllProjects;
		add: 'thread of no projects' action: #threadOfNoProjects;
		add: 'edit this thread' action: #editThisThread;
		addLine;
		add: 'First project in thread' action: #firstPage;
		add: 'Last project in thread' action: #lastPage.
	(target _ self currentIndex + 2) > listOfPages size ifFalse: [
		aMenu 
			add: 'skip over next project (',(listOfPages at: target - 1) first,')' 
			action: #skipOverNext
	].
	aMenu
		add: 'jump within this thread' action: #jumpWithinThread;
		add: 'insert new project' action: #insertNewProject;
		addLine;
		add: 'simply close this navigator' action: #delete;
		add: 'destroy this thread' action: #destroyThread.

	aMenu popUpEvent: self world primaryHand lastEvent in: self world! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 3/5/2001 21:16'!
skipOverNext
	
	| target |

	(target _ self currentIndex + 2) > listOfPages size ifTrue: [^1 beep].
	currentIndex _ target.
	self loadPageWithProgress.
! !

