'From Squeak3.1alpha of 28 February 2001 [latest update: #4027] on 16 May 2001 at 4:57:14 pm'!
"Change Set:		RemoveWin32Support
Date:			16 May 2001
Author:			Andreas Raab

Remove the Win32 accelerator support code - it's going to be bundled with the standard windows support code so there's no point in leaving it in the image."!


!B3DAcceleratorPlugin class methodsFor: 'translation' stamp: 'ar 5/16/2001 16:57'!
translateOn: cg inlining: inlineFlag to: fullName local: localFlag
	| files path |
	super translateOn: cg inlining: inlineFlag to: fullName local: localFlag.
	files _ #(
		(sqOpenGLRendererHeaderFile 'sqOpenGLRenderer.h')
		(sqOpenGLRendererFile 'sqOpenGLRenderer.c')
	).
	(Smalltalk platformName = 'Mac OS') ifTrue:[
		files _ files, #(
			(sqMacOpenGLHeaderFile 'sqMacOpenGL.h')
			(sqMacOpenGLFile 'sqMacOpenGL.c')
			(sqMacOpenGLInfoFile 'sqMacOpenGLInfo')
		).
	].
	path _ (FileDirectory dirPathFor: fullName), FileDirectory slash.
	files do:[:spec|
		self storeString: (self perform: spec first) onFileNamed: path, spec last.
	].
! !

B3DAcceleratorPlugin class removeSelector: #sqWin32D3DFile!
B3DAcceleratorPlugin class removeSelector: #sqWin32OpenGLFile!
B3DAcceleratorPlugin class removeSelector: #sqWin32OpenGLHeaderFile!
