'From Squeak3.1alpha of 28 February 2001 [latest update: #4030] on 16 May 2001 at 5:24:27 pm'!
"Change Set:		B3DCleanup-ar
Date:			16 May 2001
Author:			Andreas Raab

The change set cleans up various leftovers from the prior attempt of HW acceleration which are simply obsolete."!


!B3DHardwareEngine methodsFor: 'morphic-support' stamp: 'ar 5/16/2001 17:15'!
provideOverlayCanvasDuring: aBlock
	"Hand the sender a canvas that can be used for overlayed drawing.
	For now, we only provide one for renderers with direct frame buffer access.
	At some point I really want to revisit this scheme and use the overlay
	canvas for drawing the morphs in front but I don't have the time right now."
	target ifNil:[^self].
	target getCanvas translateBy: bufRect origin negated during: aBlock.! !


!Project methodsFor: 'initialization' stamp: 'ar 5/16/2001 17:08'!
installNewDisplay: extent depth: depth
	"When entering a new project, install a new Display if necessary."
	^Display setExtent: extent depth: depth! !


!WonderlandCameraMorph methodsFor: 'drawing' stamp: 'ar 5/16/2001 17:09'!
areasRemainingToFill: aRectangle
	^(myCamera drawSceneBackground)
		ifTrue:[aRectangle areasOutside: self bounds]
		ifFalse:[Array with: aRectangle]! !

!WonderlandCameraMorph methodsFor: 'menu' stamp: 'ar 5/16/2001 17:10'!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	aCustomMenu addUpdating: #firstPersonControlString action: #toggleFirstPersonControl.
	aCustomMenu addUpdating: #showControlsString action: #toggleCameraControls.
	aCustomMenu addUpdating: #getAcceleratorState action: #toggleAcceleratorState.
	aCustomMenu addLine.
	aCustomMenu add: 'Stop/Go button' action: #attachStopGoButtons.
	aCustomMenu add: 'Load actor' action: #loadActor.
! !

WonderlandCameraMorph removeSelector: #bgCacheValid!
WonderlandCameraMorph removeSelector: #releaseCachedState!
WonderlandCameraMorph removeSelector: #snapshotBackgroundString!
WonderlandCameraMorph removeSelector: #toggleSnapshotBackground!
ExternalScreen removeSelector: #allocateOrRecycleTexture:!
ExternalScreen removeSelector: #allocateTexture:!
ExternalScreen removeSelector: #depthOfTexture:!
ExternalScreen removeSelector: #destroyTexture:!
ExternalScreen removeSelector: #heightOfTexture:!
ExternalScreen removeSelector: #primAllocateTexture:width:height:!
ExternalScreen removeSelector: #primDestroyTexture:!
ExternalScreen removeSelector: #primGetTextureDepth:!
ExternalScreen removeSelector: #primGetTextureHeight:!
ExternalScreen removeSelector: #primGetTextureWidth:!
ExternalScreen removeSelector: #primTexture:colorMasksInto:!
ExternalScreen removeSelector: #rgbaBitMasksOfTexture:!
ExternalScreen removeSelector: #textureHandleOf:!
ExternalScreen removeSelector: #widthOfTexture:!
DisplayScreen removeSelector: #isB3DDisplayScreen!
Smalltalk removeClassNamed: #B3DDisplayScreen!
Smalltalk removeClassNamed: #B3DHardwareRasterizer!
Smalltalk removeClassNamed: #ExternalTexture!
