'From Squeak3.1alpha of 28 February 2001 [latest update: #4054] on 22 May 2001 at 10:14:14 pm'!
"Change Set:		supplies-sw
Date:			22 May 2001
Author:			Scott Wallace

Assures that when an image that has shared flaps currently disabled is launched as a plug-in image on behalf of an etoy that expects the Supplies flap to be present, the Supplies flap will indeed be present."!


!ProjectLauncher methodsFor: 'initialization' stamp: 'sw 5/22/2001 22:13'!
setupFlaps
	"Only called when the image has been launched in a browser.  If I am requested to show etoy flaps, then remove any pre-existing shared flaps and put up the supplies flap only.  if I am requested to show all flaps, then if flaps already exist, use them as is, else set up to show the default set of standard flaps."

	whichFlaps = 'etoy'
		ifTrue:
			[Project current flapsSuppressed: false.
			Flaps setUpSuppliesFlapOnly].
	whichFlaps = 'all'
		ifTrue: [Flaps sharedFlapsAllowed
				ifFalse: [Flaps enableGlobalFlaps]]! !

