'From Squeak3.2alpha of 2 October 2001 [latest update: #4411] on 3 October 2001 at 12:34:24 am'!
"Change Set:		playerPhraseType-sw
Date:			2 October 2001
Author:			Scott Wallace

For classic tiles, makes the result-type of commands *not* be #Player, so that player-valued tiles no longer will accept drops of them, to avoid the easy  construction of undesirable statements such as

	car forward by 5 turn by 5

"!


!TilePadMorph methodsFor: 'mouse' stamp: 'sw 10/2/2001 16:15'!
canAccept: aMorph
	"Answer whether this pad can accept the given morph"

	((aMorph isKindOf: PhraseTileMorph) or: [aMorph isKindOf: TileMorph]) 		ifTrue:
			[^ (aMorph resultType == type) "or:
				[(aMorph resultType == #unknown) and: [type == #Player]]"].
	^ false
! !

