'From Squeak3.2gamma of 17 January 2002 [latest update: #4889] on 23 June 2002 at 1:36:02 pm'!
"Change Set:		resourceColorFix
Date:			23 June 2002
Author:			Bob Arning

When loading resource Forms, do NOT discard color table information. It was only with the advent of update 4878 that this became an issue."!


!Form methodsFor: 'resources' stamp: 'RAA 6/23/2002 13:34'!
readNativeResourceFrom: byteStream
	| img aStream |
	(byteStream isKindOf: FileStream) ifTrue:[
		"Ugly, but ImageReadWriter will send #reset which is implemented as #reopen and we may not be able to do so."
		aStream _ RWBinaryOrTextStream with: byteStream contents.
	] ifFalse:[
		aStream _ byteStream.
	].
	img _ [ImageReadWriter formFromStream: aStream] on: Error do:[:ex| nil].
	img ifNil:[^nil].
	img displayOn: self.
	img _ nil.! !

