'From Squeak3.3alpha of 30 January 2002 [latest update: #4924] on 24 July 2002 at 12:20:08 pm'!
"Change Set:		fixAllCat-sw
Date:			24 July 2002
Author:			Scott Wallace

Fix up methods that had '-- all --' as their home category"!


!Utilities class methodsFor: 'miscellaneous' stamp: 'sw 7/24/2002 12:19'!
fixUpProblemsWithAllCategory
	"Moves all methods that are in formally classified a category named '-- all --' into the default 'as yet unclassified' category"

	"Utilities fixUpProblemsWithAllCategory"

	| org aCategory methodCount classCount any |
	methodCount _ 0.
	classCount _ 0.
	Smalltalk allBehaviorsDo:
		[:aClass | org _ aClass organization.
			(org categories includes: #'-- all --') ifTrue:
				[any _ false.
				aClass selectorsDo:
					[:aSelector |
						aCategory _ org categoryOfElement: aSelector.
						aCategory = #'-- all --' ifTrue:
							[org classify: aSelector under: ClassOrganizer default suppressIfDefault: false.
							Transcript cr; show: aClass name, ' >> ', aSelector.
							methodCount _ methodCount + 1.
							any _ true]].
			any ifTrue: [classCount _ classCount + 1].
			org removeEmptyCategories]].
	Transcript cr; show: methodCount printString, ' methods in ', classCount printString, ' classes moved from "-- all --" to "as yet unclassified"'
! !

"Postscript:"
Utilities fixUpProblemsWithAllCategory.
!

