'From Squeak3.3alpha of 18 January 2002 [latest update: #4937] on 31 July 2002 at 6:03:34 pm'!
"Change Set:		debuggerFix-sw
Date:			29 July 2002
Author:			Scott Wallace

Fixes a bug introduced in update4487SyntaxErrorsOnFileIn-svp (October 2001) which compromised the mvc environment whenever a debugger was brought up.  The workaround here, done without any pretension to deep knowledge of the underlying issues, is to restore the method in question (Debugger >> process:controller:context:isolationHead:) to its former behavior in the mvc case, while letting it work its putative magic in morphic."!


!Debugger methodsFor: 'private' stamp: 'sw 7/29/2002 23:27'!
process: aProcess controller: aController context: aContext isolationHead: projectOrNil

	super initialize.
	Smalltalk at: #MessageTally ifPresentAndInMemory: [:c | c new close].
	contents _ nil. 
	interruptedProcess _ aProcess.
	interruptedController _ aController.
	contextStackTop _ aContext.
	self newStack: (contextStackTop stackOfSize: 1).
	contextStackIndex _ 1.
	externalInterrupt _ false.
	selectingPC _ true.
	isolationHead _ projectOrNil.
	Smalltalk isMorphic ifTrue:
		[errorWasInUIProcess _ false]! !

