'From Squeak3.3alpha of 18 January 2002 [latest update: #4938] on 4 August 2002 at 6:09:48 pm'!
"Change Set:		fasterPopUp-sw
Date:			4 August 2002
Author:			Scott Wallace

Reduces unnecessary invalidation upon display of pop-up menus in morphic by precomputing the contents of dynamic menu items directly rather than via preliminary insertion into the world."!


!MenuMorph methodsFor: 'control' stamp: 'sw 8/4/2002 17:55'!
popUpAt: aPoint forHand: hand in: aWorld allowKeyboard: aBoolean
	"Present this menu at the given point under control of the given hand."

	| evt |
	self items isEmpty ifTrue: [^ self].
	(self submorphs select: [:m | m isKindOf: UpdatingMenuItemMorph]) do:
		[:m | m updateContents].  "precompute width"
	self positionAt: aPoint relativeTo: (selectedItem ifNil: [self items first]) inWorld: aWorld.
	aWorld addMorphFront: self.

	"Acquire focus for valid pop up behavior"
	hand newMouseFocus: self.
	aBoolean ifTrue: [hand newKeyboardFocus: self].
	evt _ hand lastEvent.
	(evt isKeyboard or: [evt isMouse and: [evt anyButtonPressed not]]) ifTrue:
		["Select first item if button not down"
		self moveSelectionDown: 1 event: evt].
	self changed! !

