'From Squeak3.2 of 22 February 2002 [latest update: #4952] on 15 October 2002 at 12:15:45 pm'!
"Change Set:		Translucent-tk
Date:			15 October 2002
Author:			Ted Kaehler

Change the drawOn: of SketchMorph and ThreePhaseButtonMorph to use the alpha channel of the Form they own.  Allows feathered edges on buttons and EToy objects.  

Also, (Morph setProperties: aList) lets you set many properties at once.  The list is like #(eyes blue hair gray weight 150)"!


!Morph methodsFor: 'access properties' stamp: 'tk 10/9/2002 08:30'!
setProperties: aList
	"Set many properties at once from a list of prop, value, prop, value"

	1 to: aList size by: 2 do: [:ii |
		self setProperty: (aList at: ii) toValue: (aList at: ii+1)].! !


!FlapTab methodsFor: 'accessing' stamp: 'tk 9/25/2002 18:08'!
labelString
	^labelString! !


!SketchMorph methodsFor: 'drawing' stamp: 'tk 10/9/2002 09:15'!
drawOn: aCanvas
	aCanvas translucentImage: self rotatedForm at: bounds origin
! !


!ThreePhaseButtonMorph methodsFor: 'drawing' stamp: 'tk 10/9/2002 10:20'!
drawOn: aCanvas

	state == #off ifTrue: [
		offImage ifNotNil: [aCanvas translucentImage: offImage at: bounds origin]].
	state == #pressed ifTrue: [
		pressedImage ifNotNil: [aCanvas translucentImage: pressedImage at: bounds origin]].
	state == #on ifTrue: [
		image ifNotNil: [aCanvas translucentImage: image at: bounds origin]].! !

