'From TeaSqueak3.2 of 5 November 2002 [latest update: #312] on 9 November 2002 at 12:01:54 am'!
"Change Set:		croquetCompat-sw
Date:			8 November 2002
Author:			Scott Wallace

Changes UpdatingStringMorph.informTarget to be mutually compatible with 3.4a and Croquet"!


!UpdatingStringMorph methodsFor: 'target access' stamp: 'sw 11/8/2002 23:52'!
informTarget
	"Obtain a value from my contents, and tell my target about it.  The putSelector can take one argument (traditional) or two (as used by Croquet)"

	| newValue typeIn |
	((target ~~ nil) and: [putSelector ~~ nil]) ifTrue:
		[typeIn _ contents.
		(newValue _ self valueFromContents) ifNotNil:
			[self checkTarget.
			putSelector numArgs = 1 
				ifTrue:
					[target perform: putSelector with: newValue].
			putSelector numArgs = 2
				ifTrue:
					[target perform: putSelector with: newValue with: self].
			target isMorph ifTrue: [target changed]].
			self fitContents.

			(format == #default and: [newValue isNumber]) ifTrue:
				[self setDecimalPlacesFromTypeIn: typeIn]]! !

