'From Squeak 2.3 beta of Nov 25, 1998 on 4 January 1999 at 9:23:19 pm'!
"Change Set:		SetDepthTweak
Date:			4 January 1999
Author:			Dan Ingalls

Causes SystemWindows to be repainted white when changing to monochrome display, and back when reverting to color.
"!


!HandMorph methodsFor: 'world menu commands' stamp: 'di 1/4/1999 21:17'!
setDisplayDepth
	"Let the user choose a new depth for the display. "
	| result oldDepth |
	oldDepth _ Display depth.
	(result _ (SelectionMenu selections: #('1' '2' '4' '8' '16' '32')) startUpWithCaption: 'Choose a display depth
(it is currently ' , oldDepth printString , ')') == nil ifFalse:
		[Display newDepth: result asNumber].
	(World isMorph and: [(Display depth < 4) ~= (oldDepth < 4)]) ifTrue:
		["Repaint windows since they look better all white in depth < 4"
		(SystemWindow windowsIn: World satisfying: [:w | true]) do:
			[:w | w updatePaneColors]]! !


!SystemWindow methodsFor: 'panes' stamp: 'di 1/4/1999 21:19'!
updatePaneColors
	"Useful when changing from monochrome to color display"

	self setStripeColorsFrom: self paneColor.
	paneMorphs do: [:p | p color: self paneColor].
! !


