'From Squeak3.6beta of ''4 July 2003'' [latest update: #5331] on 12 July 2003 at 10:40:24 am'!
"Change Set:		ImportsUndeclaredFix-nk
Date:			12 July 2003
Author:			Ned Konz

CS 5296KCP68Imports caused an Undeclared reference to #default that came from Imports>>default. I assume that #default was meant to be a class instance variable; this code does this.

The postscript of this change set deals with the Undeclared reference.
"
!

Object subclass: #Imports
	instanceVariableNames: 'imports '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Support'!
Imports class
	instanceVariableNames: 'default '!

!Imports class methodsFor: 'instance creation' stamp: 'nk 7/12/2003 10:38'!
default
	"Answer my default instance, creating one if necessary."
	"Imports default"
	^default ifNil: [ default _ self new ]! !

!Imports class methodsFor: 'instance creation' stamp: 'nk 7/12/2003 10:36'!
default: anImports
	"Set my default instance. Returns the old value if any."
	| old |
	old _ default.
	default _ anImports.
	^old! !

"Postscript:
The postscript of this change set deals with the Undeclared reference."

Undeclared at: #default ifPresent: [ :def |
	def class == Imports ifTrue: [ Undeclared removeKey: #default. Imports default: def ]].!

