'From Squeak 2.3 of January 14, 1999 on 28 January 1999 at 3:55:04 pm'!
"Change Set:		versionTweak-sw
Date:			28 January 1999
Author:			Scott Wallace

Upon a versions request where there are no prior versions, tells the user the time-stamp.

Also fixes things such that our new response to a no-prior-versions situation now works the same way in change sorters that it works in other kinds of browsers."!


!ChangeList class methodsFor: 'public access' stamp: 'sw 1/28/1999 15:52'!
browseVersionsOf: method class: class meta: meta category: category selector: selector 
	^ self browseVersionsOf: method class: class meta: meta category: category selector: selector lostMethodPointer: nil! !

!ChangeList class methodsFor: 'public access' stamp: 'sw 1/28/1999 15:48'!
browseVersionsOf: method class: class meta: meta category: category selector: selector lostMethodPointer: sourcePointer
	| changeList actualClass aMethod stamp line1 |
	Cursor read showWhile:
		[changeList _ self new
			scanVersionsOf: method class: class meta: meta
			category: category selector: selector].
	changeList
		ifNil:
			[self inform: 'No versions available']
		ifNotNil:
			[changeList listHasSingleEntry ifTrue:
				[actualClass _ meta ifTrue: [class class] ifFalse: [class].
				aMethod _ actualClass compiledMethodAt: selector ifAbsent: [nil].
				stamp _ aMethod ifNotNil: [Utilities timeStampForMethod: aMethod].
				line1 _ stamp ifNil: [''] ifNotNil: [stamp, '
'].
			(self confirm: line1,
'No older versions of this method.
View the current version anyway?')
					ifFalse: [^ self]].
	sourcePointer ifNotNil:
		[changeList setLostMethodPointer: sourcePointer].

			self open: changeList name: 'Recent versions of ' ,
selector multiSelect: false]! !


