'From Squeak 2.3 of January 14, 1999 on 6 April 1999 at 10:27:06 am'!
"Change Set:		envEditorFix-jhm
Date:			6 April 1999
Author:			John Maloney

Two minor fixes to the envelope editor having to do with
the recent change to String>asNumber."
!


!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'jm 4/6/1999 10:21'!
durationName

	self durationChoices do: [:c |
		(c first isDigit and: [c asNumber = sampleDuration]) ifTrue: [^ c]].
	sampleDuration = 9999 ifTrue: [^ 'held'].
	^ sampleDuration printString
! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'jm 4/6/1999 10:22'!
chooseFrom: chooserMorph durationItem: item
	| str |
	(item first isDigit and: [item asNumber ~= 0])
		ifTrue: [sampleDuration _ item asNumber].
	item = 'other' ifTrue:
		[str _ FillInTheBlank request: 'duration in milliseconds'
						initialAnswer: sampleDuration printString.
		sampleDuration _ str asNumber].
	item = 'held' ifTrue: [sampleDuration _ 9999].
	sound duration: sampleDuration / 1000.0.
	chooserMorph contentsClipped: 'duration: ' , self durationName! !


