'From Squeak3.1alpha of 28 February 2001 [latest update: #3874] on 22 March 2001 at 12:05:39 pm'!
"Change Set:		menuFixes-sw
Date:			22 March 2001
Author:			Scott Wallace

Fixes the bug that brought up the wrong shifted-menu for a code pane when the 'more...' branch was followed.  Also includes Tim Rowledge's fix for the class-list menu of a FileContentsBrowser"!


!FileContentsBrowser methodsFor: 'menus' stamp: 'tpr 3/11/2001 21:26'!
classListMenu: aMenu shifted: ignored
	"Answer the class list menu, ignoring the state of the shift key in this case"

	^ self classListMenu: aMenu! !


!MouseMenuController methodsFor: 'pluggable menus' stamp: 'sw 3/22/2001 12:03'!
shiftedTextPaneMenuRequest
	"The user chose the more... branch from the text-pane menu."

	^ self pluggableYellowButtonActivity: true! !


!ParagraphEditor class methodsFor: 'class initialization' stamp: 'sw 3/22/2001 12:02'!
initializeTextEditorMenus
	"Initialize the yellow button pop-up menu and corresponding messages."

	"ParagraphEditor initializeTextEditorMenus"

	TextEditorYellowButtonMenu _ SelectionMenu
		labels: 
'find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
accept (s)
cancel (l)
show bytecodes
more...' 
		lines: #(3 5 9 12 14 15)
		selections: #(find findAgain setSearchString again undo copySelection cut paste pasteRecent doIt printIt inspectIt accept cancel showBytecodes shiftedTextPaneMenuRequest)! !


!ScrollPane methodsFor: 'scroll bar events' stamp: 'sw 3/22/2001 12:03'!
shiftedTextPaneMenuRequest
	"The more... button was hit from the text-pane menu"

	^ self yellowButtonActivity: true! !

"Postscript:"
ParagraphEditor initializeTextEditorMenus.
!

