'From Squeak3.1alpha of 7 March 2001 [latest update: #4019] on 17 May 2001 at 7:35:56 pm'!
"Change Set:		RecompileUpdateCS-AFi
Date:			17 May 2001
Author:			Alain Fischer

Changing definition of a class force a compilation of the class
and the metaclass methods through Behavior>>recompile:from:
With the old method, the current ChangeSet is not updated which
could let some obsolete reference in the system causing problems
when you try to save a project.
The new method update the current ChangeSet in a way similar to
the one used when you accept change to a method in a code pane."!


!Behavior methodsFor: 'creating method dictionary' stamp: 'AFi 5/17/2001 19:11'!
recompile: selector from: oldClass
	"Compile the method associated with selector in the receiver's method dictionary."
	"ar 7/10/1999: Use oldClass compiledMethodAt: not self compiledMethodAt:"
	"AFi 5/17/2001: Update ChangeSet"

	| method trailer methodNode priorMethodOrNil newMethod |
	method _ oldClass compiledMethodAt: selector.
	trailer _ (method endPC + 1 to: method size) collect: [:i | method at: i].
	methodNode _ self compilerClass new
				compile: (oldClass sourceCodeAt: selector)
				in: self
				notifying: nil
				ifFail: [^ self].   "Assume OK after proceed from SyntaxError"
	selector == methodNode selector ifFalse: [self error: 'selector changed!!'].
	priorMethodOrNil _ (self methodDict includesKey: selector)
		ifTrue: [self compiledMethodAt: selector]
		ifFalse: [nil].
	newMethod _ methodNode generate: trailer.
	Smalltalk changes noteNewMethod: newMethod forClass: self
		selector: selector priorMethod: priorMethodOrNil.
	self addSelector: selector withMethod: newMethod.
! !


