'From Squeak3.1alpha of 7 February 2001 [latest update: #3536] on 9 February 2001 at 1:37:18 am'!
"Change Set:		FileMenuAdditions-dew
Date:			9 February 2001
Author:			Doug Way

Adds 'fileIn', 'file into new change set', and 'browse code' menu items to the file (text area) menu, to go along with 'browse changes' (so that it's similar to the file list menu).  This will make it easier for people to file in and browse changesets if they open them via the open.../file... menu.  Also removes 'fileIn selection', since it's already in the shift menu."!


!FileList methodsFor: 'file list menu' stamp: 'dew 2/9/2001 01:13'!
fileContentsMenu: aMenu shifted: shifted

| shiftMenu |
^ shifted 
	ifFalse: [aMenu 
		labels: 
'get entire file
view as hex
fileIn
file into new change set
browse changes
browse code
find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
accept (s)
cancel (l)
more...' 
		lines: #(2 6 9 11 15 18 20)
		selections: #(get getHex
fileInSelection fileIntoNewChangeSet browseChanges browseFile
find findAgain setSearchString
again undo
copySelection cut paste pasteRecent
doIt printIt inspectIt
accept cancel
shiftedYellowButtonActivity)]

	ifTrue: [shiftMenu _ ParagraphEditor shiftedYellowButtonMenu.
		aMenu 
			labels: shiftMenu labelString 
			lines: shiftMenu lineArray
			selections: shiftMenu selections]

! !

