'From Squeak3.1alpha of 7 March 2001 [latest update: #4332] on 11 September 2001 at 11:37:27 pm'!
"Change Set:		GrabRotatedMorphFix-bf
Date:			11 September 2001
Author:			Bert Freudenberg

If you have a morph with holes, or that is simply non-rectangular, and you rotate it, the transparent areas won't let mouse clicks through anymore. Just paint a zig-zag line, rotate it, and you can grab it even by clicking in between the zig-zags.  This surely breaks the illusion of the 'thingness' of self-painted objects.  Fix by removing a fullBounds send in TransformMorph>>containsPoint:."!


!TransformMorph methodsFor: 'geometry' stamp: 'bf 9/11/2001 23:29'!
containsPoint: aPoint
	(bounds containsPoint: aPoint) ifFalse: [^ false].
	self hasSubmorphs
		ifTrue: [self submorphsDo: 
					[:m | (m containsPoint: (transform globalPointToLocal: aPoint))
							ifTrue: [^ true]].
				^ false]
		ifFalse: [^ true]! !

