'From Squeak3.1alpha of 28 February 2001 [latest update: #4405] on 2 October 2001 at 5:20:53 pm'!
"Change Set:		deoptimize-sw
Date:			2 October 2001
Author:			Scott Wallace

An 'optimization' in update 4393StringMorphOptimize-nk broke at least some prominent uses of UpdatingStringMorph, including the Viewers and Watchers so central to etoys.  This update takes the old pre-optimized StringMorph version of #contents: and places it in UpdatingStringMorph, leaving Ned's optimized version intact up in StringMorph."!


!UpdatingStringMorph methodsFor: 'accessing' stamp: 'sw 10/2/2001 17:11'!
contents: newContents
	"This is the original StringMorph implementation of #contents:, restored down in UpdatingStringMorph because a recent 'optimization' of the StringMorph version of this method broke UpdatingStringMorphs."

	newContents isText
		ifTrue: [emphasis _ newContents emphasisAt: 1.
				contents _ newContents string]
		ifFalse: [contents = newContents ifTrue: [^ self].  "no substantive change"
				contents _ newContents].
	self fitContents.
	self changed

! !

