'From Squeak3.2alpha of 11 October 2001 [latest update: #4567] on 30 November 2001 at 10:47:07 pm'!
"Change Set:		fixScrollbarOnRight-sm
Date:			30 November 2001
Author:			Simon Michael

Outboard scrollbars on the right have not been usable in browsers, because they appeared behind the neighboring pane to the right and disappeared when you moused over them. This change attempts to remedy that by bringing the current pane (and it's owner, for the class pane in browsers) to the front when showing a scroll bar."!


!ScrollPane methodsFor: 'scrolling' stamp: 'sm 11/30/2001 22:32'!
showScrollBar
	(submorphs includes: scrollBar)
		ifTrue: [^ self].
	self resizeScrollBar.
	self privateAddMorph: scrollBar atIndex: 1.
	"scrollBar changed."
	scrollBarOnLeft
		ifFalse: [
			"Bring the pane to the front so that it is fully visible"
			self comeToFront.
			self owner comeToFront].
	retractableScrollBar
		ifFalse: [self resetExtent]
! !

