'From Squeak3.3alpha of 18 January 2002 [latest update: #4821] on 8 April 2002 at 1:06:15 am'!
"Change Set:		catCompat-sw
Date:			8 April 2002
Author:			Scott Wallace

Adds a compatibility method that allows one to create fileouts with class-definitions that will have appropriate category designations whether loaded into a premodule or module-aware image.  The allows us to avoid the annoyance of having inappropriate system category names applied to new classes that are defined in fileouts retrofitted from 3.3x back to 3.2x, though at the price of manually editing the fileouts.!


!Class methodsFor: 'subclass creation' stamp: 'sw 4/8/2002 01:03'!
subclass: t instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat module: mod
	"Dispatch either to the module-aware or the non-module-aware class-definition method.  Calls can be hand-fiddled in fileouts to make for ingratiating categorization in both environments]"

	^ ((Smalltalk at: #Module ifAbsent: [nil]) isKindOf: Class)
		ifTrue:
			[self subclass: t instanceVariableNames: f classVariableNames: d module: mod]
		ifFalse:
			[self subclass: t instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat]! !

