'From Squeak3.3alpha of 18 January 2002 [latest update: #4879] on 28 May 2002 at 6:47:35 pm'!
"Change Set:		flasher-sd
Date:			17 April 2002
Author:			Stephane Ducasse

Cleanups for the Flasher.  No longer directly accesses color inst var."!


!Flasher methodsFor: 'initialization' stamp: 'sd 4/21/2002 09:36'!
initializeToStandAlone
	"Initialize the flasher."

	super initializeToStandAlone.
	self color: Color red.
	self onColor: Color red. 
	self borderWidth: 2.
	self extent: 25@25! !

!Flasher methodsFor: 'stepping' stamp: 'sw 5/28/2002 18:45'!
step
	"Perform my standard periodic action"

	super step.
	self color = self onColor
		ifTrue: [self color: (onColor alphaMixed: 0.5 with: Color black)]
		ifFalse: [self color: onColor]! !

!Flasher methodsFor: 'operations' stamp: 'sw 5/28/2002 18:44'!
onColor
	"Answer my onColor"

	^ onColor ifNil: [onColor _ Color red]! !

!Flasher methodsFor: 'operations' stamp: 'sd 4/21/2002 09:55'!
onColor: aColor
	"Change my on color to be aColor"

	onColor := aColor.
	self color: aColor! !

Flasher removeSelector: #setInitialState!
