'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5278] on 25 June 2003 at 4:01:09 pm'!
"Change Set:		DropFilesEvent-fix-dgd
Date:			31 March 2003
Author:			Diego Gomez Deck <DiegoGomezDeck@ConsultAr.com>

BUG: An error occurrs when a drag event is processes and the world has not a real color (example: an InfiniteForm).  The method try to get the negated color and it fails.

FIX: an #asColor message is send to 'owner color'.  (Re-generated this changeset without prettyPrint because the loss of #second, #third, etc. messages was disturbing. -dew)
"!


!HandMorph methodsFor: 'private events' stamp: 'dgd 3/31/2003 18:22'!
generateDropFilesEvent: evtBuf 
	"Generate the appropriate mouse event for the given raw event buffer"

	"Note: This is still in an experimental phase and will need more work"

	| position buttons modifiers stamp numFiles dragType |
	stamp := evtBuf second.
	stamp = 0 ifTrue: [stamp := Time millisecondClockValue].
	dragType := evtBuf third.
	position := evtBuf fourth @ evtBuf fifth.
	buttons := 0.
	modifiers := evtBuf sixth.
	buttons := buttons bitOr: (modifiers bitShift: 3).
	numFiles := evtBuf seventh.
	dragType = 4 
		ifTrue: 
			["e.g., drop"

			owner borderWidth: 0.
			^DropFilesEvent new 
				setPosition: position
				contents: numFiles
				hand: self].
	"the others are currently not handled by morphs themselves"
	dragType = 1 
		ifTrue: 
			["experimental drag enter"

			owner
				borderWidth: 4;
				borderColor: owner color asColor negated].
	dragType = 2 
		ifTrue: 
			["experimental drag move"

			].
	dragType = 3 
		ifTrue: 
			["experimental drag leave"

			owner borderWidth: 0].
	^nil! !

