'From Squeak3.6beta of ''4 July 2003'' [latest update: #5387] on 6 August 2003 at 11:42:26 am'!
"Change Set:		BrowserRedrawFix
Date:				6 August 2003
Author:			Ned Konz

Fixes the redrawing bug in the SystemBrowser (redraw didn't remove the focus rectangles).

But only invalidates the focus rectangles, so we don't have to do a full redraw.

Since we're always grabbing keyboard focus on mouseEnter, removed conditional in mouseLeave. This will prevent a PLM from responding to keyboard events once the mouse has left its bounds."!


!PluggableListMorph methodsFor: 'event handling' stamp: 'nk 8/6/2003 11:38'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	The given argument indicates that the receiver is gaining (versus losing) the keyboard focus.
	In this case, all we need to do is to redraw border feedback"

	(self innerBounds areasOutside: (self innerBounds insetBy: 1))
		do: [ :rect | self invalidRect: rect ]! !

!PluggableListMorph methodsFor: 'events' stamp: 'nk 8/6/2003 11:25'!
mouseLeave: event
	"The mouse has left the area of the receiver"

	super mouseLeave: event.
	event hand releaseKeyboardFocus: self! !

