'From Squeak3.6 of ''6 October 2003'' [latest update: #5424] on 14 October 2003 at 11:50:35 am'!
"Change Set:		delayComment-ls
Date:			14 October 2003
Author:			Lex Spoon

Gives Delay a class comment.  Most of the text comes from the method #howToUse, which was already there but which I completely overlooked.  Since #howToUse is now redundant, it is removed."!


!Delay commentStamp: 'ls 10/14/2003 11:46' prior: 0!
I am the main way that a process may pause for some amount of time.  The simplest usage is like this:

	(Delay forSeconds: 5) wait.

An instance of Delay responds to the message 'wait' by suspending the caller's process for a certain amount of time. The duration of the pause is specified when the Delay is created with the message forMilliseconds: or forSeconds:. A Delay can be used again when the current wait has finished. For example, a clock process might repeatedly wait on a one-second Delay.

The maximum delay is (SmallInteger maxVal // 2) milliseconds, or about six days. A delay in progress when an image snapshot is saved is resumed when the snapshot is re-started. Delays work across millisecond clock roll-overs.


For a more complex example, see  #testDelayOf:for:rect: .!
]style[(763 22 2)f1,f1LDelay class testDelayOf:for:rect:;,f1!

Delay class removeSelector: #howToUse!
