'From Squeak3.6 of ''6 October 2003'' [latest update: #5424] on 9 October 2003 at 10:22:34 am'!
"Change Set:		ActionSequenceFix-nk
Date:			9 October 2003
Author:			Ned Konz

9 October:
	- removed WeakActionSequence>>isValid to avoid confusion.
	- added Object>>removeActionsSatisfying:

5 August: re-posted without Roel's fix.

30 July: first version.
	- Fixes a bug that made it impossible to say:
	someObject when: #something evaluate: (MessageSend ...)
	because MessageSend didn't understand #isValid
"!


!Object methodsFor: 'events-removing' stamp: 'nk 8/25/2003 21:46'!
removeActionsSatisfying: aBlock

	self actionMap keys do:
		[:eachEventSelector |
			self
   				removeActionsSatisfying: aBlock
				forEvent: eachEventSelector
		]! !


!MessageSend methodsFor: 'testing' stamp: 'nk 7/21/2003 15:16'!
isValid
	^true! !


!WeakActionSequence methodsFor: 'converting' stamp: 'nk 7/21/2003 15:16'!
asMinimalRepresentation

	| valid |
	valid := self select: [:e | e isValid ].
	valid size = 0
		ifTrue: [^nil].
	valid size = 1
		ifTrue: [^valid first].
	^valid! !

!WeakActionSequence methodsFor: 'evaluating' stamp: 'nk 7/21/2003 15:17'!
value
    "Answer the result of evaluating the elements of the receiver.
	Actually, return just the last result."

    | answer |
    self do:
        [:each | each isValid ifTrue: [answer := each value]].
    ^answer! !

!WeakActionSequence methodsFor: 'evaluating' stamp: 'nk 7/21/2003 15:17'!
valueWithArguments: anArray

	"Return the last result"

    | answer |
    self do:
        [:each |
        	each isValid ifTrue: [answer := each valueWithArguments: anArray]].
    ^answer! !


!WeakMessageSend methodsFor: 'testing' stamp: 'nk 8/24/2003 01:12'!
isValid
	^self isReceiverOrAnyArgumentGarbage not
! !

WeakActionSequence removeSelector: #isReceiverOrAnyArgumentGarbage!
WeakActionSequence removeSelector: #isValid!
