'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5548] on 16 November 2003 at 10:44:18 am'!
"Change Set:		CatViewFix-dgd
Date:			16 November 2003
Author:			Diego Gomez Deck <DiegoGomezDeck@ConsultAr.com>

BUG: Opening a viewer of any morph debugger apears

FIX: CategoryViewer>>addNamePaneTo: was using the unexisting preference #standardEToysFont"!


!CategoryViewer methodsFor: 'header pane' stamp: 'dgd 11/16/2003 10:38'!
addNamePaneTo: header 
	"Add the namePane, which may be a popup or a type-in 
	depending on the type of CategoryViewer"
	| aButton |
	namePane := RectangleMorph newSticky color: Color brown veryMuchLighter.
	namePane borderWidth: 0.
	aButton := (StringButtonMorph
				contents: '-----'
				font: (StrikeFont familyName: #NewYork size: 12))
				color: Color black.
	aButton target: self;
		 arguments: Array new;
		 actionSelector: #chooseCategory.
	aButton actWhen: #buttonDown.
	namePane addMorph: aButton.
	aButton position: namePane position.
	namePane align: namePane topLeft with: bounds topLeft + (50 @ 0).
	namePane setBalloonText: 'category (click here to choose a different one)' translated.
	header addMorphBack: namePane.
	(namePane isKindOf: RectangleMorph)
		ifTrue: [namePane addDropShadow.
			namePane shadowColor: Color gray]! !

