'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5423] on 3 December 2003 at 9:24:16 pm'!
"Change Set:		FileListFTPWrite-tk
Date:			3 December 2003
Author:			Ted Kaehler

The FileList supports viewing files on remote servers via FTP.  For years now, editing a file and writing it back to the server has been broken.  (Why didn't anyone complain?)  Dan finally did complain, and the problem was that the close message in RemoteFileStream was calling itself recursively.  With this fix, files on remote servers can be edited in a FileList."!


!RemoteFileStream methodsFor: 'as yet unclassified' stamp: 'tk 12/3/2003 21:04'!
close
	"Write if we have data to write.  FTP files are always binary to preserve the data exactly.  The binary/text (ascii) flag is just for tell how the bits are delivered from a read."

	remoteFile writable ifTrue: [
			remoteFile putFile: (self as: RWBinaryOrTextStream) reset named: remoteFile fileName]! !

