'From Squeakeasy0.0 of 13 May 2003 [latest update: #181] on 18 January 2004 at 10:13:15 pm'!
"Change Set:		paramTileFix-sw
Date:			18 January 2004
Author:			Scott Wallace

Fixes a bug regarding parameter tiles reported by Diego Gomez Deck.  Parameter tiles were not functioning correctly when they occurred embedded within if/then/else substructures."!


!ParameterTile methodsFor: 'access' stamp: 'sw 1/18/2004 22:12'!
scriptEditor
	"Answer the receiver's script editor.  The slightly strange code here is in order to contend with the unusual situation where a parameter tile obtained from one script editor is later dropped into a different script editor.  As long as the parameter tile is *in* a script editor, that containing scriptEditor is the one; if it is *not*, then we use the last known one"

	| aScriptEditor |
	^ (aScriptEditor _ self outermostMorphThat: [:m | m isKindOf: ScriptEditorMorph])
		ifNotNil:
			[scriptEditor _ aScriptEditor]
		ifNil:
			[scriptEditor]! !

