'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 18 February 2004 at 9:38:22 am'!
"Change Set:		DecorateDebuggerButtons-nk
Date:			18 February 2004
Author:			Ned Konz

Makes the debugger's inheritance button colored like in the Browsers.
"!


!Debugger methodsFor: 'private' stamp: 'nk 2/17/2004 21:05'!
contextStackIndex: anInteger oldContextWas: oldContext

	| newMethod |
	contextStackIndex _ anInteger.
	anInteger = 0
		ifTrue:
			[currentCompiledMethod _ theMethodNode _ tempNames _ sourceMap _ contents _ nil.
			self changed: #contextStackIndex.
			self decorateButtons.
			self contentsChanged.
			contextVariablesInspector object: nil.
			receiverInspector object: self receiver.
			^self].
	(newMethod _ oldContext == nil or:
		[oldContext method ~~ (currentCompiledMethod _ self selectedContext method)])
		ifTrue:
			[tempNames _ sourceMap _ nil.
			theMethodNode _ self selectedContext methodNode.
			contents _ self selectedMessage.
			self contentsChanged.
			self pcRange "will compute tempNamesunless noFrills"].
	self changed: #contextStackIndex.
	self decorateButtons.
	tempNames == nil
		ifTrue: [tempNames _ 
					self selectedClassOrMetaClass parserClass new parseArgsAndTemps: contents notifying: nil].
	contextVariablesInspector object: self selectedContext.
	receiverInspector object: self receiver.
	newMethod ifFalse: [self changed: #contentsSelection]! !

