'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5657] on 16 February 2004 at 1:40:48 pm'!
"Change Set:		ExportAsPNG-nk
Date:			16 February 2004
Author:			Ned Konz

This adds 'export as PNG' to the Morph export menu, now that the PNGReadWriter knows how to write.

Also adds PNG export to MenuIcons class.
"!


!MenuIcons class methodsFor: 'import/export' stamp: 'nk 2/16/2004 13:38'!
exportAllIconsAsPNG
	"self exportAllIconsAsPNG"

	| sels | 
	sels := self class selectors select: [:each |  '*Icon' match: each asString].
	sels do: [:each | self exportIcon: (MenuIcons perform: each) asPNGNamed: each asString].
! !

!MenuIcons class methodsFor: 'import/export' stamp: 'nk 2/16/2004 13:38'!
exportIcon: image asPNGNamed: aString
	"self exportIcon: self newIcon asPNGNamed: 'newIcon'"

	| writer |
	writer := PNGReadWriter on: (FileStream newFileNamed: aString, '.png').
	[ writer nextPutImage: image]	
		ensure: [writer close]! !


!Morph methodsFor: 'menus' stamp: 'nk 2/16/2004 13:29'!
addExportMenuItems: aMenu hand: aHandMorph
	"Add export items to the menu"

	aMenu ifNotNil:
		[ | aSubMenu |
		aSubMenu _ MenuMorph new defaultTarget: self.
		aSubMenu add: 'BMP file' translated action: #exportAsBMP.
		aSubMenu add: 'GIF file' translated action: #exportAsGIF.
		aSubMenu add: 'JPEG file' translated action: #exportAsJPEG.
		aSubMenu add: 'PNG file' translated action: #exportAsPNG.
		aMenu add: 'export...' translated subMenu: aSubMenu]
! !

!Morph methodsFor: 'menus' stamp: 'nk 2/16/2004 13:29'!
exportAsPNG
	| fName |
	fName _ FillInTheBlank request:'Please enter the name' initialAnswer: self externalName,'.png'.
	fName isEmpty ifTrue:[^self].
	PNGReadWriter putForm: self imageForm onFileNamed: fName.! !

