'From Squeak3.7alpha of 11 September 2003 [latest update: #5763] on 4 March 2004 at 8:40:45 pm'!
"Change Set:		StubMethodCreationCategory-rr
Date:			3 March 2004
Author:			rr


v2: stef changed the message + added translated for babel!!
+ remove the method comment which was not one :)

Adds a 10 line method, and modifies another, so that when a method is created in the debugger,
the user is asked the category in which it shoud be implemented. I hope this two-method
change is small enough to be accepted quickly, as I find it quite useful."!


!Debugger methodsFor: 'context stack menu' stamp: 'sd 3/4/2004 20:39'!
askForCategoryIn: aClass default: aString
	| categories index category |
	categories := OrderedCollection with: 'new ...'. 
	categories addAll: (aClass allMethodCategoriesIntegratedThrough: Object).	
	index := PopUpMenu withCaption: 'Please provide a good category for the new method!!' translated
						chooseFrom: categories.
	index = 0 ifTrue: [^ aString].
	category := index = 1 ifTrue: [FillInTheBlank request: 'Enter category name:']
						ifFalse: [categories at: index].
	^ category isEmpty ifTrue: [^ aString] ifFalse: [category]! !

!Debugger methodsFor: 'context stack menu' stamp: 'sd 3/4/2004 20:39'!
implement: aMessage inClass: aClass
	
	| category |
	category := self askForCategoryIn: aClass default: 'as yet unclassified'.
	aClass compile: aMessage createStubMethod classified: category.
	self selectedContext privRefreshWith: (aClass lookupSelector: aMessage selector).
	self resetContext: self selectedContext.
	self contextStackIndex: 1 oldContextWas: nil
! !

