'From Squeak3.7beta of ''1 April 2004'' [latest update: #5905] on 30 April 2004 at 1:50:45 am'!
"Change Set:		renameHTTPRequest-avi
Date:			30 April 2004
Author:			Avi Bryant

v2: rename it to HTTPDownloadRequest instead, and change its subclasses to match, per Michael's wishes.

Rename HTTPRequest to BasicHTTPRequest to avoid name conflicts with Swazoo."!

Smalltalk renameClassNamed: #HTTPRequest as: #HTTPDownloadRequest!
Smalltalk renameClassNamed: #CachedHTTPRequest as: #CachedHTTPDownloadRequest!
Smalltalk renameClassNamed: #PluginHTTPRequest as: #PluginHTTPDownloadRequest!

!CodeLoader methodsFor: 'private' stamp: 'avi 4/30/2004 01:40'!
httpRequestClass
	^HTTPDownloadRequest! !


!CachingCodeLoader methodsFor: 'private' stamp: 'avi 4/30/2004 01:40'!
httpRequestClass
	^CachedHTTPDownloadRequest
! !


!HTTPLoader class methodsFor: 'accessing' stamp: 'avi 4/30/2004 01:40'!
httpRequestClass
	^HTTPClient shouldUsePluginAPI
		ifTrue: [PluginHTTPDownloadRequest]
		ifFalse: [HTTPDownloadRequest]! !

