'From Squeak3.7-m17n of 21 July 2004 [latest update: #19] on 25 July 2004 at 3:48:06 pm'!
"Change Set:		e02PhraseInsetFix-sw
Date:			10 April 2004
Author:			Scott Wallace

When you drop a phrase from a Viewer onto the desktop and a new Scriptor sprouts around it, the tiles for that initial phrase were slightly different from the tiles for any other phrase you might subsequently drop into the Scriptor.  They had a 2-pixel inset that other phrase tiles lacked, and they also had a pale green background that extended the entire width of the Scriptor.  This update fixes both those problems.

Earlier published to Squeakland as update 0209phraseInsetFix-sw.cs; this 3.8a-intended update is identical to that."!


!ScriptEditorMorph methodsFor: 'initialization' stamp: 'sw 4/10/2004 00:59'!
phrase: aPhraseTileMorph
	"Make the receiver be a Scriptor for a new script whose initial contents is the given phrase."

	| aHolder |
	firstTileRow _ 2.
	aHolder _ AlignmentMorph newRow.
	aHolder beTransparent; layoutInset: 0.
	aHolder addMorphBack: aPhraseTileMorph.
	self addMorphBack: aHolder.
	self install! !

