'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5976] on 2 August 2004 at 5:24:56 pm'!
"Change Set:		e17browseTextualFix-sw
Date:			2 August 2004
Author:			Scott Wallace

Converts the browse-all-scripts command to use SystemNavigation"!


!Presenter methodsFor: 'playerList' stamp: 'sw 8/2/2004 17:24'!
browseAllScriptsTextually
	"Open a method-list browser on all the scripts in the project"

	| aList aMethodList |
	(aList _ self uniclassesAndCounts) size == 0 ifTrue: [^ self inform: 'there are no scripted players'].
	aMethodList _ OrderedCollection new.
	aList do:
		[:aPair | aPair first addMethodReferencesTo: aMethodList].
	aMethodList size > 0 ifFalse: [^ self inform: 'there are no scripts in this project!!'].
	
	SystemNavigation new 
		browseMessageList: aMethodList 
		name: 'All scripts in this project' 
		autoSelect: nil

"
ActiveWorld presenter browseAllScriptsTextually
"! !

