'From Squeak3.7beta of ''1 April 2004'' [latest update: #5878] on 18 April 2004 at 7:17:58 pm'!
"Change Set:		FatBitsPaintMenuFix-nk
Date:			18 April 2004
Author:			Ned Konz

Fixes a problem with the 'Tools' and 'Selection' menus in the FatBitsPaint.
"!


!FatBitsPaint methodsFor: 'events' stamp: 'nk 4/18/2004 19:04'!
toolMenu: evt
	| menu |
	menu _ MenuMorph new.
	menu
		addTitle: 'Tools';
		addStayUpItem.
	{
		{'paint brush'. self toolsForPaintBrush}.
		{'selections'. self toolsForSelection}
	} do: [:each |
		menu add: each first
			target: self
			selector: #setCurrentToolTo:
			argumentList: {each second}].
	menu toggleStayUp: evt.
	menu popUpEvent: evt in: self world! !

!FatBitsPaint methodsFor: 'menu' stamp: 'nk 4/18/2004 19:04'!
selectionMenu: evt

        | menu |
 
        (menu _ MenuMorph new)
                addTitle: 'Edit';
                addStayUpItem.

        {
                {'edit separately'. #editSelection}.
                {'copy'. #copySelection}.
                {'cut'. #cutSelection}.
                {'paste'. #pasteSelection}
        } do: [:each |
                menu add: each first
                        target: self
                        selector: each second
                        argumentList: #()].
        menu toggleStayUp: evt.
        menu popUpEvent: evt in: self world! !

