'From Squeak3.8alpha of 8 September 2004 [latest update: #6218] on 23 September 2004 at 10:02:33 am'!
"Change Set:		timespanZeroDuration-brp
Date:			23 September 2004
Author:			Brent Pinkney

The problem was identified by Ingo Hohman.

Added two new tests:
	TimespanTest>>#testZeroDuration
	TimespanTest>>#testClockPrecisionDuration.

A fix was added to Timespan>>#end

Note. A time span of zero duration is equivalent to a time span of duration equal to the clock precision (DateAndTime>>#clockPrecision).

"!


!Timespan methodsFor: 'squeak protocol' stamp: 'brp 9/23/2004 09:53'!
end


	^ self duration asNanoSeconds = 0
		ifTrue: [ self start ]
		ifFalse: [ self next start - DateAndTime clockPrecision ]! !


!TimespanTest methodsFor: 'testing' stamp: 'brp 9/23/2004 09:58'!
testClockPrecisionDuration
	| ts |
	ts := Timespan starting: Date today duration: DateAndTime clockPrecision.
	self
		assert: ts start = ts end! !

!TimespanTest methodsFor: 'testing' stamp: 'brp 9/23/2004 09:57'!
testZeroDuration
	| ts |
	ts := Timespan starting: Date today duration: Duration zero.
	self
		assert: ts start = ts end! !

