'From Small-Land 3.8-5976-0266 of 29 August 2004 [latest update: #5976] on 30 August 2004 at 9:05:38 pm'!
"Change Set:		MenuSelectionColorPreference-dgd
Date:			30 August 2004
Author:			Diego Gomez Deck

New preference to configure the menu selection color.

In absence of the preference the color will be calculated just like now is.

"
!


!MenuItemMorph methodsFor: 'drawing' stamp: 'dgd 8/30/2004 20:59'!
selectionFillStyle
	"answer the fill style to use with the receiver is the selected  
	element"
	| fill baseColor preferenced |
	Display depth <= 2
		ifTrue: [^ Color gray].

	preferenced := Preferences menuSelectionColor.
	preferenced notNil ifTrue:[^ preferenced].

	baseColor := owner color negated.
	Preferences gradientMenu
		ifFalse: [^ baseColor].
	fill := GradientFillStyle ramp: {0.0 -> baseColor twiceLighter . 1 -> baseColor twiceDarker}.
	fill origin: self topLeft.
	fill direction: self width @ 0.
	^ fill! !


!Preferences class methodsFor: 'menu parameters' stamp: 'dgd 8/30/2004 20:59'!
menuSelectionColor
	^ Parameters
		at: #menuSelectionColor
		ifAbsent: [nil]! !

