'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #348] on 3 November 2004 at 9:28:21 am'!
"Change Set:		CellSize0Guard-nk
Date:			3 November 2004
Author:			Ned Konz

Smalltalk code to guard against passing a cellSize (smoothingCount) of 0 into the WarpBlt primitives.
"!


!WarpBlt methodsFor: 'primitives' stamp: 'nk 11/3/2004 09:26'!
warpBits
	"Move those pixels!!"

	cellSize < 1 ifTrue: [ ^self error: 'cellSize must be >= 1' ].

	self warpBitsSmoothing: cellSize
		sourceMap: (sourceForm colormapIfNeededForDepth: 32).
! !

!WarpBlt methodsFor: 'system simulation' stamp: 'nk 11/3/2004 09:26'!
warpBitsSimulated
	"Simulate WarpBlt"

	cellSize < 1 ifTrue: [ ^self error: 'cellSize must be >= 1' ].

	self warpBitsSimulated: cellSize
		sourceMap: (sourceForm colormapIfNeededForDepth: 32).
! !

