'From Squeak3.9alpha of ''2 November 2004'' [latest update: #6532] on 9 January 2005 at 3:37:57 pm'!
"Change Set:		SafeToServe-wiz
Date:			9 January 2005
Author:			(wiz) Jerome Peace

Fix for Mantis bug #0000519. Navigator share button leads to emergency crash when squeak logo present.
-- slightly edited for formatting and using #inform: (bf)"!


!NebraskaServerMorph class methodsFor: 'as yet unclassified' stamp: 'wiz 1/9/2005 15:12'!
serveWorld: aWorld
	"Check to make sure things won't crash. See Mantis #0000519"
	aWorld isSafeToServe ifTrue:[
		^self serveWorld: aWorld onPort: NebraskaServer defaultPort]
	! !


!PasteUpMorph methodsFor: 'Nebraska' stamp: 'wiz 1/9/2005 15:37'!
isSafeToServe
	"True if all conditions are met to share safely. 
	(attends to mantis bug #0000519).
	Right now we reject worlds with FlashMorphs for subMorphs."

	(self findA: FlashMorph) ifNil: [^true].
	self inform: 'Can not share world if Squeaklogo is present. Collapse logo and try again'.
	^false! !

