'From Squeakland.396-Nihongo7.29 of 14 March 2005 [latest update: #66] on 17 March 2005 at 9:24:55 am'!
"Change Set:		newGraphicsFix
Date:			17 March 2005
Author:			Yoshiki Ohshima

new graphics feature of a SketchMorph raises error when it encounters 0 width or height form because it trys to create a thumnail."!


!Morph class methodsFor: 'testing' stamp: 'yo 3/17/2005 09:07'!
allSketchMorphForms
	"Answer a Set of forms of SketchMorph (sub) instances, except those 
	used as button images, ones being edited, and those with 0 extent."

	| reasonableForms form |
	reasonableForms := Set new.
	Morph allSketchMorphClasses do:
		[:cls | cls allInstances do:
			[:m | (m owner isKindOf: SketchEditorMorph orOf: IconicButton)
				ifFalse:
					[form _ m form.
					((form width > 0) and: [form height > 0]) ifTrue: [reasonableForms add: form]]]].
	^ reasonableForms! !

