'From Squeak3.8gamma of ''24 November 2004'' [latest update: #6639] on 7 April 2005 at 3:52:16 pm'!
"Change Set:		autoLoadUpdates
Date:			7 April 2005
Author:			Michael Rueger

Adds the preference updateFromServerAtStartup and modifies release builder to set it to true on a release image. Default value is false though."!


!ReleaseBuilderDeveloper methodsFor: 'utilities' stamp: 'mir 4/7/2005 11:56'!
installPreferences
	super installPreferences.
	#(
		(updateFromServerAtStartup true)

	) do:[:spec|
		Preferences setPreference: spec first toValue: spec last]! !

"Postscript:
"

	Preferences
		addPreference: #updateFromServerAtStartup
		categories: #(#updates)
		default: false
		balloonHelp: 'If true the system will check for and load any available updates'!

