'From Squeak3.10.1-basic-7160 of 11 May 2008 [latest update: #7160] on 11 May 2008 at 12:41:48 pm'!
"Change Set:		7161ObjectFlagFix-M6793-edc
Date:			11 May 2008
Author:			Edgar J. De Cleene

This is a gift from FunSqueak.
Original Mantis report was http://bugs.squeak.org/view.php?id=6793
Actual ToDo list is http://bugs.squeak.org/view.php?id=7035
Cs naming style is from Ralph
Thanks to he and to Jerome"!


!ObjectsTool methodsFor: 'categories' stamp: 'edc 12/4/2007 15:34'!
showCategory: aCategoryName fromButton: aButton 
	"Project items from the given category into my lower pane"
	| quads |
	"self partsBin removeAllMorphs. IMHO is redundant, "
	
	Cursor wait
		showWhile: [quads := OrderedCollection new.
			Morph withAllSubclasses
				do: [:aClass | aClass theNonMetaClass
						addPartsDescriptorQuadsTo: quads
						if: [:aDescription | aDescription translatedCategories includes: aCategoryName]].
			quads := quads
						asSortedCollection: [:q1 :q2 | q1 third <= q2 third].
			self installQuads: quads fromButton: aButton]! !


!PartsBin methodsFor: '*BabySRE-connectors-initialization' stamp: 'edc 12/4/2007 16:01'!
listDirection: aListDirection quadList: quadList buttonClass: buttonClass
	"Initialize the receiver to run horizontally or vertically, obtaining its elements from the list of tuples of the form:
		(<receiver> <selector> <label> <balloonHelp>)"

	| aButton aClass |
	self layoutPolicy: TableLayout new.
	self listDirection: aListDirection.
	self wrapCentering: #topLeft.
	self layoutInset: 2.
	self cellPositioning: #bottomCenter.

	aListDirection == #leftToRight
		ifTrue:
			[self vResizing: #rigid.
			self hResizing: #spaceFill.
			self wrapDirection: #topToBottom]
		ifFalse:
			[self hResizing: #rigid.
			self vResizing: #spaceFill.
			self wrapDirection: #leftToRight].
	quadList do:
		[:tuple |
			aClass _ Smalltalk at: tuple first.
			aButton _ buttonClass new .
			aButton color: self color;
		initializeToShow: (self class thumbnailForQuad: tuple) withLabel:  tuple third andSend: tuple second to: aClass.
			(tuple size > 3 and: [tuple fourth isEmptyOrNil not]) ifTrue:
				[aButton setBalloonText: tuple fourth].
 			self addMorphBack: aButton].
! !

"This is a gift from FunSqueak.
Original Mantis report was http://bugs.squeak.org/view.php?id=6793
Actual ToDo list is http://bugs.squeak.org/view.php?id=7035
Cs naming style is from Ralph
Thanks to he and to Jerome"
Flaps freshFlapsStart.
Project current showSharedFlaps.
Project current toggleFlapsSuppressed.
Project current toggleFlapsSuppressed!

