'From Squeak3.10.1 of ''26 May 2008'' [latest update: #7175] on 30 May 2008 at 11:32:33 pm'!
"Change Set:		7177ReleaseTests-M7076-wiz
Date:			30 May 2008
Author:			(wiz) Jerome Peace

wiz 5/30/2008 23:31

This combines the two tests inspired by M7070 and its proposed fix.
I also corrected my creative spelling of categories. 
"!


!ReleaseTest methodsFor: 'testing' stamp: 'wiz 5/30/2008 23:29'!
testClassesSystemCategory
"Find cases where classes have nil system categories.
This test will tell you the classes.
This is inspired by the proposed fix of a bug in release of 3.10.1 
see Mantis #7070" 
| rejectClasses | 

rejectClasses := 
 nil systemNavigation allClasses reject: [ :each |
	each category notNil ] .


self assert: rejectClasses isEmpty .

! !

!ReleaseTest methodsFor: 'testing' stamp: 'wiz 5/30/2008 23:30'!
testSystemCategoryClasses
"Find cases where system categories name absent classes.
This test will tell you the classes.
This is inspired by a bug in release of 3.10.1 
see Mantis #7070" 
|  rejectCats rejectClasses | 
rejectCats := 
SystemOrganization categories reject: [ :catName |
	(SystemOrganization listAtCategoryNamed: catName) 
		allSatisfy: [ :className | 
			( Smalltalk includesKey: className ) ] ] .
"self assert: rejectCats isEmpty ."

rejectCats isEmpty ifTrue: [ ^ true ] . 


rejectClasses :=
rejectCats collect: [ :each |
	each ->
	( (SystemOrganization listAtCategoryNamed: each) 
		reject: [ :eachOne | 
			( Smalltalk includesKey: eachOne )  ] ) ] .

self assert: rejectCats isEmpty .
! !

