'From Squeak 2.0 BETA of May 8, 1998 on 8 May 1998 at 10:01:51 pm'!
"Change Set:		jhmFileListCngFileFix
Date:			8 May 1998
Author:			John Maloney

Fixes the bug that caused the changes file to be closed if
it was selected in the FileList. (The problem was that the
FileList was opening the file r/w, instead of read-only.)"
!


!FileStream class methodsFor: 'instance creation' stamp: 'jm 5/8/1998 21:53'!
oldFileOrNoneNamed: fileName
	"If the file exists, answer a read-only FileStream on it. If it doesn't, answer nil."

	| fullName |
	fullName _ self fullName: fileName.
	(self concreteStream isAFileNamed: fullName)
		ifTrue: [^ self concreteStream readOnlyFileNamed: fullName]
		ifFalse: [^ nil].
! !
