'From Squeak 2.4b of April 23, 1999 on 9 June 1999 at 11:19 pm'!
"Change Set:		removeViewerBook-sw
Date:			10 June 1999
Author:			Scott Wallace

Removes ViewerBooks from existing image and ultimately deletes the class.  The remainder of this preamble is executable code that plays a role in this process."

| viewerTab |
TabbedPalette allInstancesDo:
	[:p | (p currentPage isKindOf: ViewerBook) ifTrue: [p showNoPalette]].
ViewerBook allInstancesDo:
	[:b | b owner ifNotNil: [b owner showNoPalette]].

IndexTabs allInstances do: 
	[:anIndexTabs |
		viewerTab _ anIndexTabs submorphs detect: [:t | (t isKindOf: StringMorph) and: [t contents = 'View']] ifNone: [nil].
		viewerTab ifNotNil:
			[anIndexTabs owner pages remove: anIndexTabs owner viewerBook ifAbsent: [].
			viewerTab delete.
			anIndexTabs laySubpartsOutInOneRow]]!


TabbedPalette removeSelector: #releaseCachedState!
TabbedPalette removeSelector: #selectViewerTab!
TabbedPalette removeSelector: #hasViewerTab!
TabbedPalette removeSelector: #viewerTab!
TabbedPalette removeSelector: #viewerBook!
Smalltalk removeClassNamed: #ViewerBook!
