'From Squeak 2.4c of May 10, 1999 on 18 July 1999 at 4:22:48 pm'!
"Change Set:		PrettyPrinting
Date:			18 July 1999
Author:			Stefan Matthias Aust

Makes browsing with prettyPrint work in the File Contents Browser.
"!


!Browser methodsFor: 'message functions' stamp: 'sma 6/16/1999 23:44'!
prettyPrint
	"Reformat the selected method"
	| selectedClass |
	((self messageListIndex = 0) | (self okToChange not))
		ifTrue: [^ self changed: #flash].
	selectedClass _ self selectedClassOrMetaClass.
	contents _ (selectedClass compilerClass new
			format: contents
			in: selectedClass
			notifying: nil) asText makeSelectorBoldIn: selectedClass.
	self contentsChanged
! !


!FileContentsBrowser methodsFor: 'edit pane' stamp: 'sma 6/17/1999 00:18'!
selectedMessage
	"Answer a copy of the source code for the selected message selector."
	| class selector |
	class _ self selectedClassOrMetaClass.
	selector _ self selectedMessageName.
	contents _ class sourceCodeAt: selector.
	Preferences browseWithPrettyPrint ifTrue: [contents _ Compiler new
					format: contents
					in: class
					notifying: nil].
	^ (self
		methodDiffFor: contents
		class: self selectedClass
		selector: self selectedMessageName
		meta: self metaClassIndicated) asText makeSelectorBoldIn: class! !


!PseudoClass methodsFor: 'accessing' stamp: 'sma 6/16/1999 22:59'!
allInstVarNames
	^#()! !

!PseudoClass methodsFor: 'printing' stamp: 'sma 6/17/1999 00:00'!
literalScannedAs: scannedLiteral notifying: requestor 
	^ scannedLiteral! !

!PseudoClass methodsFor: 'testing method dictionary' stamp: 'sma 6/17/1999 00:17'!
scopeHas: varName ifTrue: assocBlock 
	assocBlock value: varName.
	^ false! !


