'From Squeak 2.5 of August 6, 1999 on 23 October 1999 at 10:15:04 pm'!
"Change Set:		StreamFixes
Date:			23 October 1999
Author:			Hans-Martin Mosner <hmm@heeg.de>

Fixes 2 Stream issues:
PositionableStream>>match: failed to match string when the first character of the string appears just before the full occurrence of the string.
StandardFileStream>>upToEnd failed because the collection inst var is not set"!


!PositionableStream methodsFor: 'positioning' stamp: 'hmm 10/22/1999 21:18'!
match: subCollection
	"Set the access position of the receiver to be past the next occurrence of the subCollection. Answer whether subCollection is found.  No wildcards, and case does matter."

	| pattern startMatch |
	pattern _ ReadStream on: subCollection.
	startMatch _ nil.
	[pattern atEnd] whileFalse: 
		[self atEnd ifTrue: [^ false].
		(self next) = (pattern next) 
			ifTrue: [pattern position = 1 ifTrue: [startMatch _ self position]]
			ifFalse: [pattern position: 0.
					startMatch ifNotNil: [
						self position: startMatch.
						startMatch _ nil]]].
	^ true

! !


!StandardFileStream methodsFor: 'read, write, position' stamp: 'hmm 10/22/1999 20:34'!
upToEnd
	collection _ buffer1.
	^super upToEnd! !


