'From Squeak2.6 of 13 October 1999 [latest update: #1727] on 23 December 1999 at 5:06:44 pm'!
"Change Set:		FasterChgsSets-ar
Date:			23 December 1999
Author:			Andreas Raab

When having many change sets (e.g., >= 1000) gathering change sets takes a very long time. This change speeds gathering up by a factor of 25."!


!ChangeSorter class methodsFor: 'as yet unclassified' stamp: 'ar 12/23/1999 17:03'!
gatherChangeSets
	"Collect any change sets created in other projects"
	| allChangeSets obsolete |
	allChangeSets _ IdentitySet new: AllChangeSets size * 2.
	allChangeSets addAll: AllChangeSets.
	ChangeSet allSubInstancesDo: [:each |
		(allChangeSets includes: each) == (obsolete _ each isMoribund) ifTrue:[
			obsolete
				ifTrue:[AllChangeSets remove: each]
				ifFalse:[AllChangeSets add: each]]].
	^ AllChangeSets
	"ChangeSorter gatherChangeSets"! !


