'From Squeak2.8alpha of 12 January 2000 [latest update: #1811] on 4 February 2000 at 9:26:15 pm'!
"Change Set:		FasterWho
Date:			4 February 2000
Author:			Dan Ingalls

A reimplementation of CompiledMethod>>who, that runs over four times faster.
"!


!CompiledMethod methodsFor: 'printing' stamp: 'di 2/4/2000 21:13'!
who 
	"Answer an Array of the class in which the receiver is defined and the 
	selector to which it corresponds."

	| sel |
	Smalltalk allBehaviorsDo:
		[:class |
		(sel _ class methodDict keyAtIdentityValue: self ifAbsent: [nil])
			ifNotNil: [^Array with: class with: sel]].
	^ Array with: #unknown with: #unknown
! !


