'From Squeak2.7 of 5 January 2000 [latest update: #1789] on 5 February 2000 at 2:24:48 pm'!
"Change Set:		1006FishEyeFix-bf
Date:			5 January 2000
Author:			Bert Freudenberg

Refactored #magnifiedForm."!

MagnifierMorph subclass: #FishEyeMorph
	instanceVariableNames: 'gridNum d clipRects toRects quads savedExtent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Demo'!

!FishEyeMorph methodsFor: 'private' stamp: 'bf 1/5/2000 18:37'!
magnifiedForm
	| warp warpForm fromForm |

	savedExtent ~= srcExtent ifTrue: [
		savedExtent _ srcExtent.
		self calculateTransform].

	warpForm _ Form extent: srcExtent depth: Display depth.
	fromForm _ super magnifiedForm.

	warp _  (WarpBlt toForm: warpForm)
		sourceForm: fromForm;
		colorMap: nil;
		cellSize: 2;
		combinationRule: Form over.

	1 to: gridNum y do: [:j |
		1 to: gridNum x do: [:i |
			warp
				clipRect: ((clipRects at: j) at: i);
				copyQuad: ((quads at: j) at: i)
					toRect: ((toRects at: j) at: i).
		].
	].
	^warpForm
! !


FishEyeMorph removeSelector: #initializeForm!
