'From Squeak2.8alpha of 4 February 2000 [latest update: #1873] on 26 February 2000 at 7:47:31 pm'!
"Change Set:		17TTStringMorph-sma
Date:			26 February 2000
Author:			Stefan Matthias Aust

Brian Mc Enery noticed: If multiple TTSampleString's are being copied (where each instance uses the same font) then each copy will automatically have a new version of the TTFontDescription including the glyphs and the mapping table. This occurs if a TTSampleString is created out of a parts bin, or if it is duplicated using the halo menu."!


!TTSampleFontMorph methodsFor: 'copying' stamp: 'sma 2/26/2000 19:20'!
veryDeepFixupWith: deepCopier
	"If fields were weakly copied, fix them here. If they were in the 
	tree being copied, fix them up, otherwise point to the originals!!!!"

	super veryDeepFixupWith: deepCopier.
	font _ deepCopier references at: font ifAbsent: [font]! !

!TTSampleFontMorph methodsFor: 'copying' stamp: 'sma 2/26/2000 19:18'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all,
	but shared. Warning!!!! Every instance variable defined in this class
	must be handled.  We must also implement veryDeepFixupWith:.
	See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	"font _ font"
	transform _ transform veryDeepCopyWith: deepCopier.
	smoothing _ smoothing veryDeepCopyWith: deepCopier! !


