'From Squeak2.8alpha of 4 February 2000 [latest update: #1873] on 3 March 2000 at 7:34:29 pm'!
"Change Set:		TimeSince-mir
Date:			1 March 2000
Author:			Michael Rueger

Utility methods to find the delta time without the need to check for a rollover every time.
"!


!Time class methodsFor: 'general inquiries' stamp: 'mir 10/29/1999 18:27'!
milliseconds: currentTime since: lastTime
	| delta |
	"Answer the elapsed time since last recorded in milliseconds.
	Compensate for rollover."

	delta _ currentTime - lastTime.
	^delta < 0
		ifTrue: [SmallInteger maxVal + delta]
		ifFalse: [delta]
! !

!Time class methodsFor: 'general inquiries' stamp: 'mir 10/29/1999 18:24'!
millisecondsSince: lastTime
	"Answer the elapsed time since last recorded in milliseconds.
	Compensate for rollover."

	^self milliseconds: self millisecondClockValue since: lastTime! !


