'From Squeak2.8alpha of 12 January 2000 [latest update: #1996] on 19 April 2000 at 10:22:04 am'!
"Change Set:		TwoTweaks
Date:			19 April 2000
Author:			Dan Ingalls

Fixes the selector browser so that deselecting in the selector list works properly.

Fixes SequenceableCollection>>atAll: so that it returns a result of the proper species.
"!


!SelectorBrowser methodsFor: 'as yet unclassified' stamp: 'di 4/19/2000 10:11'!
messageListIndex: anInteger 
	"Set the selected message selector to be the one indexed by anInteger.
	Present all implementors in the implementors pane (class list)."

	selectorIndex _ anInteger.
	classList _ selectorIndex = 0
		ifTrue: [Array new]
		ifFalse: [Smalltalk allImplementorsOf: self selectedMessageName].
	classListIndex _ 0.
	self changed: #messageListIndex.		"update my selection"
	self changed: #classList.
! !


!SequenceableCollection methodsFor: 'accessing' stamp: 'di 4/19/2000 09:55'!
atAll: indexArray
	"Return the selected elements in order"

	| selections |
	selections _ self species new: indexArray size.
	1 to: indexArray size do: [:i | selections at: i put: (self at: (indexArray at: i))].
	^ selections! !

