'From Squeak2.8alpha of 13 January 2000 [latest update: #2081] on 9 May 2000 at 12:25:56 am'!
"Change Set:		collapseFixes-sw
Date:			9 May 2000
Author:			Scott Wallace

(1)  Preserves collapsed position so that a subsequent collapse of the same morph will send it back to the same place.

(2)  Bug fix -- 'collapse' item had not been included in menu if morph was flexed.

NB:  must come in *after* CollapseHandle-bk"!


!Morph methodsFor: 'menus' stamp: 'sw 5/9/2000 00:08'!
maybeAddCollapseItemTo: aMenu
	self topRendererOrSelf owner isWorldMorph ifTrue:
		[aMenu add: #collapse target: self action: #collapse]! !


!CollapsedMorph methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2000 00:18'!
beReplacementFor: aMorph

	| itsWorld priorPosition |
	(itsWorld _ aMorph world) ifNil: [^self].
	uncollapsedMorph _ aMorph.
			
	self setLabel: aMorph externalName.
	aMorph delete.
	itsWorld addMorphFront: self.
	self collapseOrExpand.
	(priorPosition _ aMorph valueOfProperty: #collapsedPosition ifAbsent: [nil])
	ifNotNil:
		[self position: priorPosition].
! !

!CollapsedMorph methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2000 00:14'!
collapseOrExpand
	isCollapsed
		ifTrue: 
			[uncollapsedMorph setProperty: #collapsedPosition toValue: self position.
			self delete.
			self currentWorld addMorphFront: uncollapsedMorph]
		ifFalse:
			[super collapseOrExpand]! !

