'From Squeak2.8alpha of 13 January 2000 [latest update: #2217] on 26 May 2000 at 1:44:22 pm'!
"Change Set:		keepOnStepping-sw
Date:			26 May 2000
Author:			Scott Wallace

Yikes, fixes to another significant flaw in flexing, dating back two years and more, which was masked by the bug fixed in update 2216"!


!Morph methodsFor: 'rotate scale and flex' stamp: 'sw 5/26/2000 13:38'!
addFlexShell
	"Wrap a rotating and scaling shell around this morph."

	| oldHalo flexMorph |
	oldHalo _ self halo.
	self owner addMorph:
		(flexMorph _ self newTransformationMorph asFlexOf: self).
	self transferStateToRenderer: flexMorph.
	oldHalo ifNotNil: [oldHalo setTarget: flexMorph].
	self currentWorld startSteppingSubmorphsOf: flexMorph.

	^ flexMorph! !


!TransformationMorph methodsFor: 'menu' stamp: 'sw 5/26/2000 13:42'!
removeFlexShell
	"Remove the shell used to make a morph rotatable and scalable."

	| oldHalo unflexed pensDown player |
	oldHalo _ self halo.
	submorphs isEmpty ifTrue: [^ self delete].
	unflexed _ self firstSubmorph.
	pensDown _ OrderedCollection new.
	self allMorphsDo:  "Note any pens down -- must not be down during the move"
		[:m | ((player _ m player) notNil and: [player getPenDown]) ifTrue:
			[m == player costume ifTrue:
				[pensDown add: player.
				player setPenDown: false]]].
	self submorphs do: [:m |
		m position: self center - (m extent // 2).
		owner addMorph: m].
	unflexed absorbStateFromRenderer: self.
	pensDown do: [:p | p setPenDown: true].
	oldHalo ifNotNil: [oldHalo setTarget: unflexed].
	self currentWorld startSteppingSubmorphsOf: unflexed.
	self delete.

	^ unflexed! !

