'From Squeak2.8alpha of 19 January 2000 [latest update: #2335] on 12 June 2000 at 5:54:00 pm'!
"Change Set:		dndFix
Date:			12 June 2000
Author:			Michael Rueger

Fix free cell and the DoubleClickExample to work with the latest dnd update"!


!DoubleClickExample methodsFor: 'as yet unclassified' stamp: 'mir 6/12/2000 17:53'!
startDrag: evt
	"We'll get a mouseDown first, some mouseMoves, and a mouseUp event last"
	| oldCenter |
	evt isMouseDown ifTrue:
		[self showBalloon: 'drag (mouse down)'.
		self world displayWorld.
		(Delay forMilliseconds: 750) wait].
	evt isMouseUp ifTrue:
		[self showBalloon: 'drag (mouse up)'].
	(evt isMouseUp or: [evt isMouseDown]) ifFalse:
		[self showBalloon: 'drag (mouse still down)'].
	(self containsPoint: evt cursorPoint)
		ifFalse: [^ self].

	oldCenter _ self center.
	color = Color red
		ifTrue:
			[self extent: self extent + (1@1)]
		ifFalse:
			[self extent: ((self extent - (1@1)) max: (16@16))].
	self center: oldCenter! !


!PlayingCardMorph methodsFor: 'events' stamp: 'mir 6/12/2000 17:49'!
startDrag: evt
	| root popUp |
	evt isMouseDown ifTrue:
		[root _ owner rootForGrabOf: self.
		root == nil
			ifTrue: ["Display hidden card in front"
					popUp _ self copy.
					self board owner owner addMorphFront: popUp.
					self world displayWorld.
					(Delay forMilliseconds: 750) wait.
					popUp delete]
			ifFalse: [evt hand grabMorph: root]]! !

PlayingCardMorph removeSelector: #drag:!
DoubleClickExample removeSelector: #drag:!
