'From Squeak2.8 of 13 June 2000 [latest update: #2345] on 6 July 2000 at 4:59:21 pm'!
"Change Set:		fixBigFontCR
Date:			6 July 2000
Author:			Bob Arning

When zero-width characters were replaced with something of substance, some fonts acquired a gray carriage return. This change set makes these white to avoid the ugly artifact at the end of a line"!


!StrikeFont methodsFor: 'character shapes' stamp: 'RAA 7/6/2000 16:50'!
makeCarriageReturnsWhite
	| crForm |
	"Some larger fonts have a gray carriage return (from the zero wide fixup) make it white so it doesn't show"

	crForm _ self characterFormAt: 13 asCharacter.
	crForm fillWhite.
	self characterFormAt: 13 asCharacter put: crForm.
! !

"Postscript:
Replace all carriage returns with an all-white form (some became gray in an earlier change)."
StrikeFont allInstancesDo: [:f | f makeCarriageReturnsWhite]!

