'From Squeak2.9alpha of 17 July 2000 [latest update: #2550] on 1 September 2000 at 7:52:32 am'!
"Change Set:		miscFixes
Date:			31 August 2000
Author:			Bob Arning

- initialize EToySenderMorph with user's name and IP address when taken from new morph menu
- fixed walkback when deleting ProjectNavigationMorph from the control menu"!


!EToySenderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 8/31/2000 18:32'!
initialize

	Socket initializeNetwork.				"we may want our IP address"
	Preferences defaultAuthorName.		"seems like a good place to insure we have a name"
	super initialize.
	orientation _ #vertical.
	color _ Color lightMagenta.
	inset _ 4.
	borderColor _ Color magenta.
	borderWidth _ 4.
	self setProperty: #normalBorderColor toValue: borderColor.
	self setProperty: #flashingColors toValue: {Color red. Color yellow}.

! !

!EToySenderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 8/31/2000 18:31'!
installModelIn: myWorld

	"if we get this far and nothing exists, make it up"

	userPicture ifNotNil: [^self].
	self
		userName: Preferences defaultAuthorName 
		userPicture: nil 
		userEmail: 'who@where.net' 
		userIPAddress: NetNameResolver localAddressString
! !


!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/1/2000 07:51'!
mouseLeave: evt

	self world ifNil: [^self].		"can happen after delete from control menu"
	(self worldBounds containsPoint: evt cursorPoint) ifFalse: [^self].
	mouseInside _ false.
	self positionVertically.
! !

