'From Squeak2.9alpha of 13 June 2000 [latest update: #2558] on 3 September 2000 at 1:56:29 pm'!
"Change Set:		010-SmallestContest-dns
Author: David N Smith
This is a candidate for the most trivial bug ever submitted here. In class Morph is the method drawMouseDownHiglightOn:. Note that it is missing an h (in Higlight). Other methods called by this one, and other methods using the words HighLight in their names include the h.

The fix is obviously to add back the 'h', and change the lone caller to match.

Dave"!


!Morph methodsFor: 'drawing' stamp: '   9/3/2000 13:55'!
drawMouseDownHighlightOn: aCanvas
	self highlightedForMouseDown ifTrue: [
		aCanvas frameRectangle: self fullBounds color: self color darker darker].! !

!Morph methodsFor: 'drawing' stamp: '   9/3/2000 13:56'!
fullDrawOn: aCanvas
	"Draw the full Morphic structure on the given Canvas"

	self visible ifFalse: [^ self].
	(self hasProperty: #errorOnDraw) ifTrue:[^self drawErrorOn: aCanvas].
	aCanvas drawMorph: self.
	self drawSubmorphsOn:aCanvas.
	self drawDropHighlightOn: aCanvas.
	self drawMouseDownHighlightOn: aCanvas
! !

Morph removeSelector: #drawMouseDownHiglightOn:!
