'From Squeak2.9alpha of 13 June 2000 [latest update: #2944] on 4 November 2000 at 5:56:37 pm'!
"Change Set:		DupFix-ar
Date:			4 November 2000
Author:			Andreas Raab

A fix for duplicating morphs in transformed environments."!


!Morph methodsFor: 'meta-actions' stamp: 'ar 11/4/2000 17:56'!
duplicateMorph: evt
	"Make and return a duplicate of the receiver's argument"
	| dup |
	dup _ self duplicate.
	evt hand grabMorph: dup from: owner. "duplicate was ownerless so use #grabMorph:from: here"
	^dup! !


!HaloMorph methodsFor: 'private' stamp: 'ar 11/4/2000 17:53'!
doDup: evt with: dupHandle
	"Ask hand to duplicate my target."
	evt hand obtainHalo: self.
	(target isKindOf: SelectionMorph) ifTrue:
		[^ target doDup: evt fromHalo: self handle: dupHandle].
	self setTarget: (target duplicateMorph: evt).
	self removeAllHandlesBut: dupHandle.
	self step. "update position if necessary"
	evt hand addMouseListener: self. "Listen for the drop"! !

!HaloMorph methodsFor: 'private' stamp: 'ar 11/4/2000 17:53'!
doGrab: evt with: grabHandle
	"Ask hand to grab my target."
	evt hand obtainHalo: self.
	self removeAllHandlesBut: grabHandle.  "remove all other handles"
	evt hand grabMorph: target.
	self step. "update position if necessary"
	evt hand addMouseListener: self. "Listen for the drop"! !

