'From Squeak2.9alpha of 12 June 2000 [latest update: #3275] on 17 January 2001 at 4:11:02 pm'!
"Change Set:		BetterCodeChangeTest
Date:			17 January 2001
Author:			Dan Ingalls

Fixes a breakdown of the smartUpdate feature for the case where the methods in question do not have source code pointers.
"!


!CodeHolder methodsFor: 'self-updating' stamp: 'di 1/17/2001 16:05'!
didCodeChangeElsewhere
	"Determine whether the code for the currently selected method and class has been changed somewhere else."

	| aClass aSelector aCompiledMethod |
	currentCompiledMethod ifNil: [^ false].
	(aClass _ self selectedClassOrMetaClass) ifNil: [^ false].
	(aSelector _ self selectedMessageName) ifNil: [^ false].
	^ ((aCompiledMethod _ aClass compiledMethodAt: aSelector ifAbsent: [^ false]) ~~ currentCompiledMethod)
		and: [aCompiledMethod last ~= 0 "either not yet installed"
				or: [currentCompiledMethod last = 0 "or these methods don't have source pointers"]]
	! !

