'From Squeak2.9alpha of 17 July 2000 [latest update: #3307] on 26 January 2001 at 9:58:05 am'!
"Change Set:		PasswordFix
Date:			28 December 2000
Author:			Joshua Gargus

Fixed use of obsolete (removed) method to use its replacement. (#typeWithDefault is replacing #type)"!


!Password methodsFor: 'accessing' stamp: 'jcg 12/28/2000 21:02'!
passwordFor: serverDir
	"Returned the password from one of many sources.  OK if send in a nil arg."

	| sp msg |
	cache ifNotNil: [^ cache].
	sequence ifNotNil: [
		(sp _ self serverPasswords) ifNotNil: [
			sequence <= sp size ifTrue: [^ sp at: sequence]]].
	msg _ (serverDir isKindOf: ServerDirectory)
		ifTrue: [serverDir moniker]
		ifFalse: ['this directory'].
	(serverDir user = 'anonymous') & (serverDir typeWithDefault == #ftp) ifTrue: [
			^ cache _ FillInTheBlank request: 'Please let this anonymous ftp\server know your email address.\This is the polite thing to do.' withCRs
			initialAnswer: 'yourName@company.com'].

	^ cache _ FillInTheBlank requestPassword: 'Password for ', msg, ':'.
		"Diff between empty string and abort?"! !

