'From Squeak2.9alpha of 17 July 2000 [latest update: #3308] on 26 January 2001 at 10:56:37 am'!
"Change Set:		fixWildSelections
Date:			26 January 2001
Author:			Bob Arning

When clicking on text that has some action associated with it, there was often a strange selection of text when the action completed. This change set fixes that."!


!TextMorphEditor methodsFor: 'events' stamp: 'RAA 1/26/2001 10:55'!
mouseDown: evt 
	"An attempt to break up the old processRedButton code into threee phases"
	| clickPoint |

	oldInterval _ startBlock stringIndex to: stopBlock stringIndex - 1.
	clickPoint _ evt cursorPoint.
	(paragraph clickAt: clickPoint for: model controller: self) ifTrue: [
		oldInterval _ pivotBlock _ nil.	"don't change selection based on this click"
		evt hand releaseKeyboardFocus: self.
		^ self].
	sensor leftShiftDown
		ifFalse:
			[self closeTypeIn.
			stopBlock _ startBlock _ pivotBlock _
				paragraph characterBlockAtPoint: clickPoint]
		ifTrue:
			[(paragraph characterBlockAtPoint: clickPoint) <= startBlock
				ifTrue: [stopBlock _ startBlock.
						pivotBlock _ stopBlock]
				ifFalse: [startBlock _  stopBlock.
						pivotBlock _ startBlock].
			self closeTypeIn].
	self storeSelectionInParagraph! !

