'From Squeak3.1alpha [latest update: #''Squeak3.1alpha'' of 28 February 2001 update 3897] on 3 April 2001 at 10:46:25 pm'!
"Change Set:		tileScriptorFix-sw
Date:			3 April 2001
Author:			Scott Wallace

Fixes error encountered when switching a tool to tiles when it has no current selection."!


!CodeHolder methodsFor: 'tiles' stamp: 'sw 4/3/2001 22:42'!
installTilesForSelection
	"Install universal tiles into the code pane."

	| source aSelector aClass tree syn tileScriptor aWindow codePane |
	(aWindow _ self containingWindow) ifNil: [self error: 'hamna dirisha'].
	tileScriptor _  (aSelector _ self selectedMessageName)
		ifNil:
			[PluggableTileScriptorMorph new]
		ifNotNil:
			[aClass _ self selectedClassOrMetaClass classThatUnderstands:  aSelector.
			source _ aClass sourceCodeAt: aSelector.    
			tree _ Compiler new 
				parse: source 
				in: aClass 
				notifying: nil.
			(syn _ tree asMorphicSyntaxUsing: SyntaxMorph)
				parsedInClass: aClass.
			syn inAPluggableScrollPane].
	codePane _ aWindow findDeepSubmorphThat:   
		[:m | ((m isKindOf: PluggableTextMorph) and: [m getTextSelector == #contents]) or:
			[m isKindOf: PluggableTileScriptorMorph]] ifAbsent: [self error: 'no code pane'].
	tileScriptor color: aWindow paneColorToUse;
		setProperty: #hideUnneededScrollbars toValue: true;
		setProperty: #maxAutoFitSize toValue: codePane owner extent.
	aWindow replacePane: codePane with: tileScriptor.
	currentCompiledMethod _ aClass ifNotNil: [aClass compiledMethodAt: aSelector].
	tileScriptor owner clipSubmorphs: true.
	tileScriptor extent: codePane extent.! !

