'From Squeak3.1alpha of 5 February 2001 [latest update: #4048] on 20 May 2001 at 10:27:53 am'!
"Change Set:		installTextualFix
Date:			20 May 2001
Author:			Bob Arning

When reverting a browser from tiles to textual display, be sure to turn off clipSubmorphs so the scroll bar will show"!


!CodeHolder methodsFor: 'tiles' stamp: 'RAA 5/20/2001 10:27'!
installTextualCodingPane
	"Install text into the code pane"

	| aWindow codePane aPane boundsToUse |
	(aWindow _ self containingWindow) ifNil: [self error: 'where''s that window?'].
	codePane _ aWindow findDeepSubmorphThat:   
		[:m | ((m isKindOf: PluggableTextMorph) and: [m getTextSelector == #contents]) or:
			[m isKindOf: PluggableTileScriptorMorph]] ifAbsent: [self error: 'no code pane'].
	aPane _ self buildMorphicCodePaneWith: nil.
	boundsToUse _ (codePane bounds origin- (1@1)) corner: (codePane owner bounds corner " (1@1").
	aWindow replacePane: codePane with: aPane.
	aPane vResizing: #spaceFill; hResizing: #spaceFill; borderWidth: 0.
	aPane bounds: boundsToUse.
	aPane owner clipSubmorphs: false.

	self contentsChanged! !

