'From Squeak3.1alpha of 5 February 2001 [latest update: #4267] on 20 August 2001 at 1:15:25 pm'!
"Change Set:		collabTools
Date:			20 August 2001
Author:			Bob Arning

Adjust various morphs so that they appear in the new objects tool"!

EToyCommunicatorMorph subclass: #AudioChatGUI
	instanceVariableNames: 'mycodec myrecorder mytargetip myalert playOnArrival theConnectButton soundBlockNumber soundMessageID queueForMultipleSends transmitWhileRecording theTalkButton handsFreeTalking handsFreeTalkingFlashTime '
	classVariableNames: 'DebugLog LiveMessages NewAudioMessages PlayOnArrival '
	poolDictionaries: ''
	category: 'Morphic-Collaborative'!
EToyChatOrBadgeMorph subclass: #EToyChatMorph
	instanceVariableNames: 'listener receivingPane myForm recipientForm acceptOnCR sendingPane '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Collaborative'!
EToyCommunicatorMorph subclass: #EToyFridgeMorph
	instanceVariableNames: 'recipients incomingRow recipientRow updateCounter groupMode '
	classVariableNames: 'FridgeRecipients NewItems TheFridgeForm UpdateCounter '
	poolDictionaries: ''
	category: 'Morphic-Collaborative'!
EToyCommunicatorMorph subclass: #EToyListenerMorph
	instanceVariableNames: 'listener updateCounter '
	classVariableNames: 'GlobalIncomingQueue GlobalListener QueueSemaphore UpdateCounter WasListeningAtShutdown '
	poolDictionaries: ''
	category: 'Morphic-Collaborative'!
EToyCommunicatorMorph subclass: #EToyMorphsWelcomeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Collaborative'!
EToyChatMorph subclass: #EToyMultiChatMorph
	instanceVariableNames: 'targetIPAddresses '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Collaborative'!
EToyChatOrBadgeMorph subclass: #EToySenderMorph
	instanceVariableNames: 'userPicture '
	classVariableNames: 'DEBUG '
	poolDictionaries: ''
	category: 'Morphic-Collaborative'!

!AudioChatGUI class methodsFor: 'as yet unclassified' stamp: 'RAA 8/20/2001 12:49'!
descriptionForPartsBin

	^ self partName: 	'Audio chat'
		categories:		#('Collaborative')
		documentation:	'A tool for talking to other Squeak uers'! !


!EToyChatMorph class methodsFor: 'as yet unclassified' stamp: 'RAA 8/20/2001 12:50'!
descriptionForPartsBin

	^ self partName: 	'Text chat'
		categories:		#('Collaborative')
		documentation:	'A tool for sending messages to other Squeak uers'! !


!EToyFridgeMorph class methodsFor: 'as yet unclassified' stamp: 'RAA 8/20/2001 12:50'!
descriptionForPartsBin

	^ self partName: 	'Fridge'
		categories:		#('Collaborative')
		documentation:	'A tool for sending objects to other Squeak uers'! !


!EToyListenerMorph class methodsFor: 'as yet unclassified' stamp: 'RAA 8/20/2001 12:51'!
descriptionForPartsBin

	^ self partName: 	'Listener'
		categories:		#('Collaborative')
		documentation:	'A tool for receiving things from other Squeak uers'! !


!EToyMorphsWelcomeMorph methodsFor: 'as yet unclassified' stamp: 'RAA 8/20/2001 13:00'!
initialize

	| earMorph |
	super initialize.
	color _ Color yellow.
	self layoutInset: 8@8.
	"earMorph _ (EToyListenerMorph makeListeningToggle: true) asMorph."

	earMorph _ TextMorph new
		contents: 'Morphs
welcome
here';
		fontName: #ComicBold size: 18;
		centered;
		lock.
	self addARow: {earMorph}.
	self setBalloonText: 
			'My presence in this world means received morphs may appear automatically'.
! !


!EToyMorphsWelcomeMorph class methodsFor: 'as yet unclassified' stamp: 'RAA 8/20/2001 12:52'!
descriptionForPartsBin

	^ self partName: 	'Welcome'
		categories:		#('Collaborative')
		documentation:	'A sign that you accept morphs dropped directly into your world'! !


!EToyMultiChatMorph class methodsFor: 'as yet unclassified' stamp: 'RAA 8/20/2001 12:53'!
descriptionForPartsBin

	^ self partName: 	'Text chat+'
		categories:		#('Collaborative')
		documentation:	'A tool for sending messages to several Squeak users at once'! !


!EToySenderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 8/20/2001 13:08'!
initializeToStandAlone

	super initializeToStandAlone.
	self installModelIn: ActiveWorld.
! !

!EToySenderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 8/20/2001 13:03'!
userName

	^ (self 
		findDeepSubmorphThat: [ :x | x isKindOf: StringMorph] 
		ifAbsent: [^nil]) contents
! !


!EToySenderMorph class methodsFor: 'as yet unclassified' stamp: 'RAA 8/20/2001 12:54'!
descriptionForPartsBin

	^ self partName: 	'Badge'
		categories:		#('Collaborative')
		documentation:	'A tool for collaborating with other Squeak users'! !

