'From Squeak3.1alpha of 5 February 2001 [latest update: #4336] on 13 September 2001 at 7:24:34 pm'!
"Change Set:		ClipTextSelection
Date:			13 September 2001
Author:			Dan Ingalls

Ned Konz reported text selections displaying outside the bounds of a textMorph.
This fixes the problem."!


!FormCanvas methodsFor: 'drawing' stamp: 'di 9/12/2001 21:38'!
paragraph: para bounds: bounds color: c

	| scanner |
	self setPaintColor: c.
	scanner _ (port clippedBy: (bounds translateBy: origin)) displayScannerFor: para
		foreground: (self shadowColor ifNil:[c]) background: Color transparent
		ignoreColorChanges: self shadowColor notNil.
	para displayOn: (self copyClipRect: bounds) using: scanner at: origin+ bounds topLeft.
! !

