'From Squeak3.3alpha of 11 January 2002 [latest update: #4664] on 15 February 2002 at 1:07:10 pm'!
"Change Set:		FancyNumFix-tk
Date:			15 February 2002
Author:			Ted Kaehler

Fixes this problem, as reported by Scott:
*	get a 'number-fancy' from the Objects tool
*	dropp it into a stack
*	put it onto the background
*	tell it to hold separate data for each instance
gets an error, in method SyntaxMorph.variableDocks.
"!


!SyntaxMorph methodsFor: 'card & stack' stamp: 'tk 2/15/2002 13:03'!
variableDocks
	"Answer a list of VariableDock objects for docking up my data with an instance held in my containing playfield.  For a numeric-readout tile."

	"Is CardPlayer class holding my variableDock, or should I be using the caching mechanism in Morph>>variableDocks?"
	| updatingString lab nn aGetter |
	(updatingString _ self readOut) ifNil: [^ #()].
	updatingString getSelector ifNil: [
		lab _ self submorphNamed: 'label' ifNone: [self defaultName].
		nn _ lab contents asString.
		"nn at: 1 put: nn first asUppercase."
		updatingString getSelector: (aGetter _ 'get',nn) asSymbol;
			putSelector: (ScriptingSystem setterSelectorForGetter: aGetter).
		].
	^ Array with: (VariableDock new 
			variableName: (updatingString getSelector allButFirst: 3) withFirstCharacterDownshifted 
			type: #number 
			definingMorph: updatingString 
			morphGetSelector: #valueFromContents 
			morphPutSelector: #acceptValue:)! !

