'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 13 February 2002 at 8:10:17 pm'!
"Change Set:		fixProcessDebug-nk
Date:			13 February 2002
Author:			Ned Konz

Recent changes in the debugger (in 3.2)
have broken the debugger facilities of the
Process Browser. This restores the ability
to debug a selected Process."!


!Process methodsFor: 'debugging' stamp: 'nk 2/13/2002 11:10'!
debugWithTitle: title 
	"Open a debugger on me"
	"Is this the UI process?"
	self == Processor activeProcess
		ifTrue: [[Project interruptName: title] fork.
			self suspend.
			^ self].
	myList isNil
		ifTrue: [^ self]
		ifFalse: [myList
				remove: self
				ifAbsent: [].
			self offList].
	self suspend.
	Debugger openInterrupt: title onProcess: self! !


!ProcessBrowser class methodsFor: 'process control' stamp: 'nk 2/12/2002 10:09'!
resumeProcess: aProcess
	| priority |
	priority _ self suspendedProcesses
				removeKey: aProcess
				ifAbsent: [aProcess priority].
	aProcess priority: priority.
	aProcess suspendedContext ifNotNil: [ aProcess resume ]
! !

