'From Squeak3.3alpha of 30 January 2002 [latest update: #4827] on 19 April 2002 at 8:46:23 am'!
"Change Set:		ViewBoxFix-nk
Date:			15 April 2002
Author:			Ned Konz <ned@bike-nomad.com>

If you try to make a PasteUpMorph the model in a SystemWindow, PasteUpMorph>>viewBox: assumes incorrectly that the PUM is a World.

That is, this should work:

| p w |
p _ PasteUpMorph new extent: 100@100.
w _ (SystemWindow labelled: 'whoops!!') model: p.
w addMorph: p frame: (0@0 extent: 1@1).
w openInWorld.

This change set adds some conditionals in PasteUpMorph>>viewBox: to check if the PUM is indeed a World.
"!


!PasteUpMorph methodsFor: 'project state' stamp: 'nk 4/15/2002 09:38'!
viewBox: newViewBox
	"I am now displayed within newViewBox; react."

	self isWorldMorph ifTrue: [
		(self viewBox == nil
		  or: [self viewBox extent ~= newViewBox extent])
			ifTrue: [worldState canvas: nil].
		worldState viewBox: newViewBox.
	].
	super position: newViewBox topLeft.
	fullBounds _ bounds _ newViewBox.

	"Paragraph problem workaround; clear selections to avoid screen
droppings."
	self flag: #arNote.	     "Probably unnecessary"
	self isWorldMorph ifTrue: [
		worldState handsDo: [:hand | hand releaseKeyboardFocus].
		self fullRepaintNeeded
	].
! !

