'From Squeak3.6 of ''6 October 2003'' [latest update: #5424] on 9 November 2003 at 11:57:47 pm'!
"Change Set:		5429advanceTo37-dew
Date:			10 November 2003
Author:			Doug Way

This is the last update for version 3.6.  In its postscript is an executable statement that will set the version forward to 3.7alpha if desired.  If the user declines to advance, the changeset is deleted so that updating again will still offer another chance to advance."!

"Postscript:
Offer the chance to advance the version number."
(self confirm: 'There are no further updates for Squeak 3.6;
you are using the final version of 3.6.
However, you can advance to the next alpha-testing
version of Squeak -- 3.7alpha -- if you want.
Do you wish to advance to version 3.7alpha?
[Yes] Your system will be marked as 3.7alpha, and you will
subsequently receive ''test pilot'' updates for 3.7.
[No] Your system will remain at 3.6.
DO YOU WANT TO ADVANCE to Version 3.7alpha now?')
	ifTrue: ["delete the four gamma updates because they will be re-loaded anyway, so we avoid popup messages"
			ChangeSorter removeChangeSetsNamedSuchThat:
					[:name | (name beginsWith: '542') &
							(name beginsWith: '5420') not &
							(name beginsWith: '5429') not].
			SystemVersion newVersion: 'Squeak3.7alpha'.
			SystemVersion current date: '11 September 2003'.
			self inform: 'You may now save this Version 3.7alpha image
and retrieve updates again for 3.7alpha and beyond.']
	ifFalse: ["hm, this won't work because the update# gets set to 5429 outside of this postscript"
			"ChangeSorter removeChangeSetsNamedSuchThat:
					[:name | name = '5429advanceTo37-dew']."].
!

