'From Squeak 2.3 beta of Nov 25, 1998 on 8 January 1999 at 3:17:40 pm'!
"Change Set:		WantsSteps
Date:			8 January 1999
Author:			Dan Ingalls

This changeset clarifies the wantsStep protocol for causing morphs to step.

It also establishes a false default in class Object, so that the current do-nothing catch methods for step in Morph and MorphicModel no longer imply the need for stepping.
"!


!Object methodsFor: 'testing' stamp: 'di 1/8/1999 15:04'!
wantsSteps
	"Overridden by morphic classes whose instances want to be stepped,
	or by model classes who want their morphic views to be stepped."

	^ false! !


!SystemWindow methodsFor: 'stepping' stamp: 'di 1/8/1999 15:02'!
wantsSteps
	"Return true if the model wants its view to be stepped."
	
	^ model wantsSteps! !


