'From Squeak 2.3 of January 14, 1999 on 28 January 1999 at 5:28:38 pm'!
"Change Set:		QuotedPrintable
Date:			28 January 1999
Author:			Lex Spoon

A slow but functional definition of decodeQuotedPrintable.  Used by
Celeste's MIME support."!

!String methodsFor: 'internet' stamp: 'ls 1/5/1999 17:47'!
decodeQuotedPrintable
	"Assume receiver is in MIME 'quoted-printable' encoding, and decode it."
  
	| input answer c asciiText ascii |
	input _ ReadStream on: self.
	answer _ WriteStream on: (String new: self size).
	[input atEnd] whileFalse: [
		c _ input next.
		c = $=
			ifTrue: [  "quoted character"
				input peek = Character cr
					ifTrue: [  "ignore the '=' at the end of a line"
						input next]
					ifFalse: [  "character encoding"
						asciiText _ input next: 2.
						ascii _ Integer readFrom: (ReadStream on: asciiText) base: 16.
						answer nextPut: (Character value: ascii)]]
			ifFalse: [  "ordinary character"
				answer nextPut: c]].
	^ answer contents
! !