'From Squeak 2.3 of January 14, 1999 on 20 April 1999 at 12:21:28 pm'!
"Change Set:		RemoveOSMesa-ar
Date:			20 April 1999
Author:			Andreas Raab

This change set removes the OSMesa rasterizer and associated stuff."!


!B3DRenderEngine class methodsFor: 'instance creation' stamp: 'ar 4/20/1999 12:16'!
defaultForPlatformOn: aForm
	"Return the render engine that is most appropriate for the current host platform."
	(B3DPrimitiveEngine isAvailableFor: aForm) ifTrue:[^B3DPrimitiveEngine].
	^B3DRenderEngine! !


!FileList methodsFor: 'file list menu' stamp: 'ar 4/20/1999 12:15'!
open3DSFile
	"Open a MoviePlayerMorph on the given file (must be in .3ds format)."
	| scene |
	scene _ (ThreeDSParser parseFileNamed: self fullName).
	Smalltalk isMorphic ifTrue:[
		(B3DPrimitiveEngine isAvailable) ifFalse:[
			(self confirm:'WARNING: YOU HAVE NO REAL SUPPORT FOR 3D!!
Opening this guy in Morphic will EXTREMELY time consuming.
Are you sure you want to do this?!!
(NO is probably the right answer :-)') ifFalse:[^scene inspect]].
		scene defaultCamera moveToFit: scene.
		(B3DSceneMorph new scene: scene) openInWorld.
	] ifFalse:[scene inspect].! !


B3DBox class removeSelector: #example1!
B3DBox class removeSelector: #example3!
B3DBox class removeSelector: #example4!
B3DBox class removeSelector: #example2!
Smalltalk removeClassNamed: #OSMesaHandle!
Smalltalk removeClassNamed: #OSMesaRenderEngine!
Smalltalk removeClassNamed: #OSMesaPlugin!
Smalltalk removeClassNamed: #OSMesaRasterizer!
"Postscript:
Remove the obsolete category."
SystemOrganization removeCategory:'Balloon-3D-OSMesa' asSymbol.!

