"Change Set:		scopeCheckFix-ls
Date:			19 January 2001
Author:			Lex Spoon

Reapply the scope check for temporaries and block parameters that SMA put in 1999-12"!


!Encoder methodsFor: 'encoding' stamp: 'ls 1/19/2001 12:58'!
encodeVariable: name sourceRange: range ifUnknown: action
	| varNode |
	varNode _ scopeTable at: name
			ifAbsent: 
				[(self lookupInPools: name 
					ifFound: [:assoc | varNode _ self global: assoc name: name])
					ifTrue: [varNode]
					ifFalse: [action value]].
	range ifNotNil: [
		name first isUppercase ifTrue:
			[globalSourceRanges addLast: { name. range. false }]. ].

	(varNode isTemp and: [varNode scope < 0]) ifTrue: [^self notify: 'out of scope'].

	^ varNode! !

