'From Squeak3.0 of 4 February 2001 [latest update: #3512] on 15 February 2001 at 4:04:29 pm'!
EllipseMorph subclass: #MovingEyeMorph
	instanceVariableNames: 'inner iris '
	classVariableNames: 'IrisSize '
	poolDictionaries: ''
	category: 'Morphic-Demo'!

!MovingEyeMorph methodsFor: 'as yet unclassified' stamp: 'yo 2/15/2001 15:59'!
extent: aPoint

	super extent: aPoint.
	inner extent: (self extent * ((1.0@1.0)-IrisSize)) asIntegerPoint.
	iris extent: (self extent * IrisSize) asIntegerPoint.
	inner position: (self center - (inner extent // 2)) asIntegerPoint.
! !

!MovingEyeMorph methodsFor: 'as yet unclassified' stamp: 'yo 2/15/2001 15:58'!
initialize

	super initialize.
	self color: Color black.
	inner _ EllipseMorph new.
	inner color: self color.
	inner extent: (self extent * ((1.0@1.0)-IrisSize)) asIntegerPoint.
	inner borderColor: self color.
	inner borderWidth: 0.
	iris _ EllipseMorph new.
	iris color: Color white.
	iris extent: (self extent * IrisSize) asIntegerPoint.
	self addMorphCentered: inner.
	inner addMorphCentered: iris.
	self extent: 26@33.
! !

!MovingEyeMorph methodsFor: 'as yet unclassified' stamp: 'yo 2/15/2001 15:24'!
irisPos: cp

	| a b theta x y |
	theta _ (cp - self center) theta.
	a _ inner width // 2.
	b _ inner height // 2.
	x _ a * (theta cos).
	y _ b * (theta sin).
	iris position: ((x@y) asIntegerPoint) + self center - (iris extent // 2).! !

!MovingEyeMorph methodsFor: 'as yet unclassified' stamp: 'yo 2/15/2001 15:28'!
step

	| cp |
	cp _ World primaryHand position.
	(inner containsPoint: cp) ifTrue: [
		iris position: (cp - (iris extent // 2)).
	] ifFalse: [
	    self irisPos: cp.
	]! !

!MovingEyeMorph methodsFor: 'as yet unclassified' stamp: 'yo 2/15/2001 15:38'!
stepTime

	^ 100.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MovingEyeMorph class
	instanceVariableNames: ''!

!MovingEyeMorph class methodsFor: 'as yet unclassified' stamp: 'yo 2/15/2001 16:04'!
initialize
"
	MovingEyeMorph initialize
"
	IrisSize _ (0.42@0.50).! !


MovingEyeMorph initialize!
