'From Squeak3.1alpha of 5 February 2001 [latest update: #3521] on 6 February 2001 at 12:51:50 pm'!
"Change Set:		ppBrowserFixes
Date:			6 February 2001
Author:			Stephen T. Pope

1) The package pane browser layout is busted (true bug).

2) Several users have commented that the package pane browser's yellow
color is too intense, so I make it more cream than yellow (minor GUI preference).
"!


!PackagePaneBrowser methodsFor: 'initialize-release' stamp: 'stp 2/4/2001 07:29'!
defaultBackgroundColor
	"PackagePaneBrowser openBrowser"
	"^yellow"
	^ Color
		r: 1.0
		g: 1.0
		b: 0.6! !

!PackagePaneBrowser methodsFor: 'initialize-release' stamp: 'RAA 2/6/2001 12:50'!
openAsMorphEditing: editString 
	"Create a pluggable version of all the views for a Browser, including 
	views and controllers."
	"PackagePaneBrowser openBrowser"

	| listHeight window |
	listHeight _ 0.4.
	(window _ SystemWindow labelled: 'later') model: self.
	window
		addMorph: (PluggableListMorph
				on: self
				list: #packageList
				selected: #packageListIndex
				changeSelected: #packageListIndex:
				menu: #packageMenu:
				keystroke: #packageListKey:from:)
		frame: (0 @ 0 extent: 0.15 @ listHeight).
	window
		addMorph: self buildMorphicSystemCatList
		frame: (0.15 @ 0 extent: 0.2 @ listHeight).
	self
		addClassAndSwitchesTo: window
		at: (0.35 @ 0 extent: 0.25 @ listHeight)
		plus: 0.
	window
		addMorph: self buildMorphicMessageCatList
		frame: (0.6 @ 0 extent: 0.15 @ listHeight).
	window
		addMorph: self buildMorphicMessageList
		frame: (0.75 @ 0 extent: 0.25 @ listHeight).
	self
		addLowerPanesTo: window
		at: (0 @ listHeight corner: 1 @ 1)
		with: editString.
	window setUpdatablePanesFrom: #(#packageList #systemCategoryList #classList #messageCategoryList #messageList ).
	^ window! !

