'From Squeak3.1alpha of 5 February 2001 [latest update: #3817] on 9 March 2001 at 1:26:05 am'!
"Change Set:		NonLocalReturnFix
Date:			9 March 2001
Author:			Dan Ingalls

Fixes ServerDirectory>>oldFileOrNoneNamed: so it doesn't return out of an ensured block.
"!


!ServerDirectory methodsFor: 'file directory' stamp: 'di 3/9/2001 01:25'!
oldFileOrNoneNamed: fullName
	"If the file exists, answer a read-only RemoteFileStream on it. If it doesn't, answer nil.  fullName is directory path, and does include name of the server.  Or just a simple fileName.  Do prefetch the data."
 
	| file |
	^ Cursor wait showWhile:
		[file _ self asServerFileNamed: fullName.
		file readOnly.
		"file exists ifFalse: [^ nil]."		"on the server"
		file isTypeFile
			ifTrue: [FileStream oldFileOrNoneNamed: (file fileNameRelativeTo: self)]
			ifFalse: [self streamOnBeginningOf: file]]! !

