'From Squeak3.1alpha of 28 February 2001 [latest update: #3820] on 9 March 2001 at 1:47:19 am'!
"Change Set:		flapsInNewProjects-sw
Date:			9 March 2001
Author:			Scott Wallace

Makes a newly launched project inherit from the current project its attitude toward the display of specific global flaps, and toward whether global flaps should generally be suppressed in the project."!


!Project methodsFor: 'project parameters' stamp: 'sw 3/9/2001 01:31'!
initializeProjectPreferences
	"Initialize the project's preferences from currently-prevailing preferences that are currently being held in projects in this system"
	
	projectPreferenceFlagDictionary _ Project current projectPreferenceFlagDictionary deepCopy.

	Preferences flagsHeldByProjects associationsDo:  "in case we missed some"
		[:assoc | (projectPreferenceFlagDictionary includesKey: assoc key) ifFalse:
			[projectPreferenceFlagDictionary add: assoc key -> assoc value]].
	(Project current projectParameterAt: #globalFlapsEnabledInProject) ifNotNilDo:
		[:aBoolean | self projectParameterAt: #globalFlapsEnabledInProject put:
			aBoolean].

	(Project current projectParameterAt: #disabledGlobalFlaps ifAbsent: [nil]) ifNotNilDo:
		[:flaps | self projectParameterAt: #disabledGlobalFlaps put: flaps copy]
! !

