'From Squeak3.1alpha of 4 February 2001 [latest update: #3845] on 16 March 2001 at 12:04:24 am'!
"Change Set:		LoaderDirList-ar
Date:			16 March 2001
Author:			Andreas Raab

Modify the project finder to show the current directory rather than the Squeaklet directory. Also, show the full path for the abbreviated current directory so user knows where we are."!


!FileDirectory methodsFor: 'enumeration' stamp: 'ar 3/15/2001 23:20'!
fullName
	"Return the full name of this directory."

	^pathName! !


!FileList2 methodsFor: 'as yet unclassified' stamp: 'ar 3/15/2001 23:20'!
limitedSuperSwikiDirectoryList

	| dir nameToShow dirList |

	dirList _ OrderedCollection new.
	{FileDirectory default} do: [ :each |
		dirList add: (FileDirectoryWrapper with: each name: each fullName model: self)
	].
	ServerDirectory serverNames do: [ :n | 
		dir _ ServerDirectory serverNamed: n.
		(dir isKindOf: SuperSwikiServer) ifTrue: [
			nameToShow _ n.
			dirList add: ((dir directoryWrapperClass with: dir name: nameToShow model: self)
				balloonText: dir realUrl)
		].
	].
	^dirList! !

