'From Squeak3.1alpha of 28 February 2001 [latest update: #3978] on 3 May 2001 at 1:53:18 pm'!
"Change Set:		VRMLFix-ar
Date:			3 May 2001
Author:			Andreas Raab

Fixes a problem with undefined node definitions."!


!VRMLScene methodsFor: 'node accessing' stamp: 'ar 5/3/2001 13:52'!
definedNode: nodeName ifAbsent: aBlock
	^self definedNodes at: nodeName ifAbsent: aBlock! !

!VRMLScene methodsFor: 'actions' stamp: 'ar 5/3/2001 13:52'!
routeFrom: fromNode event: outEventName to: toNode event: inEventName
	| source target |
	sourceNodes ifNil:[
		sourceNodes _ IdentitySet new.
		targetNodes _ IdentitySet new].
	source _ self definedNode: fromNode ifAbsent:[^nil].
	target _ self definedNode: toNode ifAbsent:[^nil].
	sourceNodes add: source.
	targetNodes add: target.
	source
		when: outEventName asSymbol
		send: (self eventSelectorFor: inEventName)
		to: target! !

