'From Squeak3.1alpha of 5 February 2001 [latest update: #4336] on 14 September 2001 at 7:49:45 am'!
"Change Set:		SyntaxErrorRemoveHalt
Date:			13 September 2001
Author:			Dan Ingalls

Removes a halt from the path to a Syntax Error dialog that you get if you simply execute <class> compile: 'erroneous code'.
"!


!SyntaxError class methodsFor: 'instance creation' stamp: 'di 9/14/2001 07:46'!
errorInClass: aClass withCode: codeString doitFlag: doit
	"Open a view whose model is a syntax error. The error occurred when trying to add the given method code to the given class."

	self open:
		(self new setClass: aClass
			code: codeString
			debugger: (Debugger context: thisContext)
			doitFlag: doit).
! !

