"Change Set:		Random-nextInt
Date:			26 Aug 2001
Author:			David N. Smith (IBM)

Adds a parameter check to ensure that random numbers are only generated in the valid range [1..anInteger], where anInteger >= 1."!


'From Squeak3.1alpha of 6 April 2001 [latest update: #4261] on 26 August 2001 at 6:43:54 pm'!

!Random methodsFor: 'accessing' stamp: 'dns 8/26/2001 18:43'!
nextInt: anInteger
	"Answer a random integer in the interval [1, anInteger]."

	anInteger strictlyPositive ifFalse: [ self error: 'Range must be positive' ].
	^ (self next * anInteger) truncated + 1! !
