'From Squeak3.4beta of ''1 December 2002'' [latest update: #5138] on 4 December 2002 at 9:21:05 am'!
"Change Set:		NoMacDoubleColon-nk
Date:			4 December 2002
Author:			Ned Konz

The change set 5131macRelativeFNFix-nk introduced an incorrect result for the isAbsolute test on Mac filenames starting with a double colon. This change set removes the double colon logic from the isAbsolute test.

So with this CS the isAbsolute logic is:

* fileName starts with : -> relative
* fileName starts with the name of a folder under the root -> absolute
* otherwise -> relative
"!


!MacFileDirectory class methodsFor: 'class initialization' stamp: 'nk 12/4/2002 09:18'!
isAbsolute: fileName

	"Return true if the given fileName is absolute. The cues are:
* fileName starts with : -> relative
* fileName starts with the name of a folder under the root -> absolute
* otherwise -> relative"

	^fileName first ~= $:
		and: [ FileDirectory root directoryExists: (fileName copyUpTo: $:) ]! !

