'From Squeak3.5alpha of ''7 January 2003'' [latest update: #5169] on 27 February 2003 at 11:50:41 am'!
"Change Set:		GradientFillFix-nk
Date:			27 February 2003
Author:			Ned Konz

This fixes the walkback in 3.4g that happens when you do this:

* set the desktop to display a form (use textured background).
* set gradient color

"!


!Morph methodsFor: 'visual properties' stamp: 'nk 2/27/2003 11:48'!
useGradientFill
	"Make receiver use a solid fill style (e.g., a simple color)"
	| fill color1 color2 |
	self fillStyle isGradientFill ifTrue:[^self]. "Already done"
	color1 _ self color asColor.
	color2 _ color1 negated.
	fill _ GradientFillStyle ramp: {0.0 -> color1. 1.0 -> color2}.
	fill origin: self topLeft.
	fill direction: 0 @ self bounds extent y.
	fill normal: self bounds extent x @ 0.
	fill radial: false.
	self fillStyle: fill! !

