'From Squeak3.4 of 1 March 2003 [latest update: #5170] on 30 March 2003 at 6:31:09 pm'!
"Change Set:		PNGMineType-dgd
Date:			30 March 2003
Author:			Diego Gomez Deck <DiegoGomezDeck@ConsultAr.com>

- add a new mime type for png images.
-- see FileDirectory class>>initializeStandardMIMETypes

This change allows to drag and drop a png image from the outer space to squeak and handle it correctly.
"!


!FileDirectory class methodsFor: 'class initialization' stamp: 'dgd 3/30/2003 18:27'!
initializeStandardMIMETypes
	"FileDirectory initializeStandardMIMETypes"
	StandardMIMEMappings _ Dictionary new.
	#(
		(gif		('image/gif'))
		(pdf	('application/pdf'))
		(aiff	('audio/aiff'))
		(bmp	('image/bmp'))
		(png	('image/png'))
		(swf	('application/x-shockwave-flash'))
		(htm	('text/html' 'text/plain'))
		(html	('text/html' 'text/plain'))
		(jpg	('image/jpeg'))
		(jpeg	('image/jpeg'))
		(mid	('audio/midi'))
		(midi	('audio/midi'))
		(mp3	('audio/mpeg'))
		(mpeg	('video/mpeg'))
		(mpg	('video/mpg'))
		(txt		('text/plain'))
		(text	('text/plain'))
		(mov	('video/quicktime'))
		(qt		('video/quicktime'))
		(tif		('image/tiff'))
		(tiff	('image/tiff'))
		(ttf		('application/x-truetypefont'))
		(wrl	('model/vrml'))
		(vrml	('model/vrml'))
		(wav	('audio/wav'))
	) do:[:spec|
		StandardMIMEMappings at: spec first asString put: spec last.
	].! !

"Postscript:
"

FileDirectory initializeStandardMIMETypes.
!

