'From Squeak3.6gamma of ''11 September 2003'' [latest update: #5420] on 17 September 2003 at 12:05:12 am'!
"Change Set:		DeprecationPreference-avi
Date:			16 September 2003
Author:			Avi Bryant

Adds a preference to control whether or not to show warnings for deprecated methods.  The preference is off by default.  (added deprecatedExplanation: implementation -dew)"!


!Object methodsFor: 'error handling' stamp: 'avi 9/16/2003 11:44'!
deprecated: aBlock explanation: aString 
	 "Warn that the sender has been deprecated. answer the value of aBlock on resumption"

	Preferences showDeprecationWarnings ifTrue:
		[Deprecation
			signal: thisContext sender printString, ' has been deprecated. ', aString].
	^ aBlock value.
! !

!Object methodsFor: 'error handling' stamp: 'dew 9/17/2003 00:02'!
deprecatedExplanation: aString
	"Warn that the sending method has been deprecated"

	Preferences showDeprecationWarnings ifTrue:
		[Deprecation signal: thisContext sender printString, ' has been deprecated. ', aString]! !


!Preferences class methodsFor: 'standard queries'!
showDeprecationWarnings
	^ self
		valueOfFlag: #showDeprecationWarnings
		ifAbsent: [false]! !

"Postscript:
Add the #showDeprecationWarnings preference"
Preferences addPreference: #showDeprecationWarnings category: #debug default: false balloonHelp: 'Warn the user when a deprecated method is used.'.
!

