'From Squeak3.6gamma of ''11 September 2003'' [latest update: #5423] on 29 September 2003 at 4:56:38 pm'!
"Change Set:		CompilationNotificationFix-nk
Date:			29 September 2003
Author:			Ned Konz

This fixes the problem with compilation notification that keeps DVS and Monticello from noticing certain class changes, most notably in Morph classes.
"!


!Morph class methodsFor: 'misc' stamp: 'nk 9/29/2003 15:53'!
noteCompilationOf: aSelector meta: isMeta
	"Any change to an additionsToViewer... method can invalidate existing etoy vocabularies"

	(isMeta and: [aSelector beginsWith: 'additionsToViewer']) ifTrue:
		[Vocabulary changeMadeToViewerAdditions].
	super noteCompilationOf: aSelector meta: isMeta! !


!StandardScriptingSystem class methodsFor: 'class initialization' stamp: 'nk 9/29/2003 12:07'!
noteCompilationOf: aSelector meta: isMeta
	aSelector == #wordingForOperator: ifTrue:
		[Vocabulary changeMadeToViewerAdditions].
	super noteCompilationOf: aSelector meta: isMeta! !

