'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5566] on 26 November 2003 at 5:57:47 pm'!
"Change Set:		SocketLocalAddressLocalPortFix-mu
Date:			26 November 2003
Author:			Masashi Umezawa

Socket>>localAddress, localPort always wait incoming connections, but this behavior is not needed if the socket is already waiting connections.

-To see the problem:
socket _ Socket newTCP.
socket listenOn: 8089.
socket localPort. ""before the patch it returns 0 after connection timeout""

"!


!Socket methodsFor: 'accessing' stamp: 'MU 11/26/2003 16:53'!
localAddress
	self isWaitingForConnection
		ifFalse: [[self waitForConnectionFor: Socket standardTimeout]
				on: ConnectionTimedOut
				do: [:ex | ^ ByteArray new: 4]].
	^ self primSocketLocalAddress: socketHandle! !

!Socket methodsFor: 'accessing' stamp: 'MU 11/26/2003 16:53'!
localPort
	self isWaitingForConnection
		ifFalse: [[self waitForConnectionFor: Socket standardTimeout]
				on: ConnectionTimedOut
				do: [:ex | ^ 0]].
	^ self primSocketLocalPort: socketHandle! !

