'From Squeakeasy0.0 of 13 May 2003 [latest update: #159] on 26 December 2003 at 7:36:04 pm'!
"Change Set:		addInstVarFix-sw
Date:			26 December 2003
Author:			Scott Wallace

The removal of the extra space at the end of the instVarString in update variableDefinition-lr broke Class>>addInstVarName:, which had relied on the presence of that space.  This update fixes that."!


!Class methodsFor: 'instance variables' stamp: 'sw 12/26/2003 19:30'!
addInstVarName: aString
	"Add the argument, aString, as one of the receiver's instance variables."
	^(ClassBuilder new)
		name: self name
		inEnvironment: self environment
		subclassOf: superclass
		type: self typeOfClass
		instanceVariableNames: self instanceVariablesString, ' ', aString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category
! !

