'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 17 February 2004 at 2:02:43 am'!
"Change Set:		SCN-compileInobtrusivelyFix-avi
Date:			17 February 2004
Author:			Avi Bryant

Just a simple fix that adds an overlooked send to #uniqueInstance when referencing SystemChangeNotification in ClassDescription>>compileInobtrusively:classified:."!


!ClassDescription methodsFor: 'deprecated' stamp: 'avi 2/17/2004 01:59'!
compileInobtrusively: code classified: category
	"Compile the code and classify the resulting method in the given category, leaving no trail in  the system log, nor in any change set, nor in the 'recent submissions' list.  This should only be used when you know for sure that the compilation will succeed."

	| methodNode newMethod |
	self deprecated: 'Use compileSilently:classified: instead.'.
	
	methodNode _ self compilerClass new compile: code in: self notifying: nil ifFail: [^ nil].
	self addSelectorSilently: methodNode selector withMethod: (newMethod _ methodNode generate: #(0 0 0 0)).
	SystemChangeNotifier uniqueInstance doSilently: [self organization classify: methodNode selector under: category].
	^ newMethod! !

