'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5976] on 5 August 2004 at 1:03:26 pm'!

!FtpUrl methodsFor: 'downloading' stamp: 'mir 8/5/2004 11:55'!
downloadUrl
	"Returns a http download url for the location defined by this url."
	| ans |
	ans _ WriteStream on: String new.
	ans nextPutAll: self schemeName.
	ans nextPutAll: '://'.
	ans nextPutAll: self authority.
	port ifNotNil: [ans nextPut: $:; print: port].
	path do: [ :pathElem |
		ans nextPut: $/.
		ans nextPutAll: pathElem encodeForHTTP. ].
	self query isNil ifFalse: [ 
		ans nextPut: $?.
		ans nextPutAll: self query. ].
	self fragment isNil ifFalse: [
		ans nextPut: $#.
		ans nextPutAll: self fragment encodeForHTTP. ].
	
	^ans contents! !


!SmalltalkImage methodsFor: 'image, changes names' stamp: 'mir 8/5/2004 11:58'!
currentChangeSetString
	"SmalltalkImage current currentChangeSetString"
	^ 'Current Change Set: ', ChangeSet current name! !

!SmalltalkImage methodsFor: 'sources, changes log' stamp: 'mir 8/5/2004 11:59'!
aboutThisSystem 
	"Identify software version"

	^ self inform: self systemInformationString withCRs.! !


!ZipArchiveMember methodsFor: 'accessing' stamp: 'mir 8/5/2004 11:00'!
contentStream
	"Answer my contents as a text stream.
	Default is no conversion, since we don't know what the bytes mean."

	| s |
	s _ MultiByteBinaryOrTextStream on: (String new: self uncompressedSize).
	s converter: Latin1TextConverter new.
	self extractTo: s.
	s reset.
	^ s.
! !

