'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5976] on 31 July 2004 at 3:21:31 pm'!
"Change Set:		ObjectExplorerStepFix-nk
Date:			31 July 2004
Author:			Ned Konz

Fixes failure to save projects containing an ObjectExplorer that is 'monitoring changes'.
"!


!ObjectExplorer methodsFor: 'monitoring' stamp: 'nk 7/31/2004 15:02'!
monitor: anObjectExplorerWrapper
	"Start stepping and watching the given wrapper for changes."
	anObjectExplorerWrapper ifNil: [ ^self ].
	self world ifNil: [ ^self ].
	self monitorList at: anObjectExplorerWrapper put: anObjectExplorerWrapper asString.
	self world startStepping: self at: Time millisecondClockValue selector: #step arguments: #() stepTime: 200.! !

!ObjectExplorer methodsFor: 'monitoring' stamp: 'nk 7/31/2004 15:01'!
release
	self world ifNotNil: [ self world stopStepping: self selector: #step ].
	super release.! !

!ObjectExplorer methodsFor: 'monitoring' stamp: 'nk 7/31/2004 15:01'!
stopMonitoring
	monitorList _ nil.
	self world stopStepping: self selector: #step! !

!ObjectExplorer methodsFor: 'monitoring' stamp: 'nk 7/31/2004 15:01'!
world
	^ActiveWorld! !


!ObjectExplorer reorganize!
('accessing' contentsSelection doItContext doItReceiver explorerFor: getList label object parentObject selector)
('menus' chasePointers codePaneMenu:shifted: defsOfSelection exploreSelection explorerKey:from: genericMenu: inspectSelection objectReferencesToSelection referencesToSelection selectedClass trash trash:)
('user interface' initialExtent openBrowser: openExplorerFor:)
('error handling' doesNotUnderstand:)
('monitoring' monitor: monitorList release shouldGetStepsFrom: step stopMonitoring world)
('stepping')
!

