'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #326] on 7 October 2004 at 6:28:29 pm'!
"Change Set:		ScriptFontFix-nk
Date:			7 October 2004
Author:			Ned Konz

Brute force repair for old ScriptEditorMorphs: convert all the fonts used by their StringMorphs into the current Etoys font and fix the layout.

Fixes bug# 0000089
"!


!ScriptEditorMorph methodsFor: 'menu' stamp: 'nk 10/7/2004 18:16'!
fixLayout
	"Tell all morphs that their layout has changed, using a sledge-hammer"
	"fix fonts and layout"
	self
		allMorphsDo: [:m | (m isKindOf: StringMorph)
				ifTrue: [m font: Preferences standardEToysFont;
						 fitContents]
				ifFalse: [(m isKindOf: PhraseTileMorph)
						ifTrue: [m minCellSize: 0 @ (Preferences standardEToysFont height rounded + 10)]]].

	self allMorphs do: [:e | e layoutChanged].! !

!ScriptEditorMorph methodsFor: 'other' stamp: 'nk 10/7/2004 18:25'!
unhibernate
	"Recreate my tiles from my method if I have new universal tiles."

	self topEditor == self ifFalse: [^self].	"Part of a compound test"
	self updateHeader.
	self world ifNil: 
			[(playerScripted isNil or: [playerScripted isUniversalTiles not]) 
				ifTrue: [^self]]
		ifNotNil: [
			self fixLayout.
			Preferences universalTiles ifFalse: [^self]].
	self insertUniversalTiles.
	self showingMethodPane: false! !

