'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #347] on 2 November 2004 at 5:01:22 pm'!
"Change Set:		saveFix-sw
Date:			2 November 2004
Author:			Scott Wallace

Fixes bug that could thwart save-morph-in-file if a scriptor were dismissed after a tile drop."!

!ScriptEditorMorph methodsFor: 'buttons' stamp: 'sw 11/2/2004 16:41'!
dismiss
	"Dismiss the scriptor, usually nondestructively"

	owner ifNil: [^ self].
	scriptName ifNil: [^ self delete].  "ad hoc fixup for bkwrd compat"
	(playerScripted isExpendableScript: scriptName) ifTrue: [playerScripted removeScript: scriptName  fromWorld: self world].
	handWithTile _ nil.
	self delete! !

!ScriptEditorMorph methodsFor: 'caching' stamp: 'sw 11/2/2004 16:40'!
releaseCachedState
	"Release any state that could be recomputed"

	super releaseCachedState.
	handWithTile _ nil.
	self hibernate! !

!ScriptEditorMorph methodsFor: 'caching' stamp: 'sw 11/2/2004 17:00'!
resetHandWithTile
	"Set the handWithTile back to nil, in case it somehow got to be nonnil"

	handWithTile _ nil! !

!ScriptEditorMorph methodsFor: 'copying' stamp: 'sw 11/2/2004 16:56'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	scriptName _ scriptName veryDeepCopyWith: deepCopier.
	firstTileRow _ firstTileRow veryDeepCopyWith: deepCopier.
	timeStamp _ timeStamp veryDeepCopyWith: deepCopier.
	playerScripted _ playerScripted.		"Weakly copied"
	handWithTile _ nil.  "Just a cache"
	showingMethodPane _ showingMethodPane.	"boolean"! !

"Postscript:"
ScriptEditorMorph allSubInstancesDo: [:m | m resetHandWithTile].
!

