'From Squeak3.8gamma of ''24 November 2004'' [latest update: #6527] on 22 February 2005 at 1:27:32 pm'!
"Change Set:		FixAnimatedGIFReading-nk
Date:			22 February 2005
Author:			Ned Konz

Fixes reading of animated GIFs by removing an unintended shadowing of the 'offset' instance variable.
"!


!AnimatedGIFReadWriter methodsFor: 'accessing' stamp: 'nk 2/22/2005 13:20'!
allImages
	| body colorTable |
	stream class == ReadWriteStream ifFalse: [
		stream binary.
		self on: (ReadWriteStream with: (stream contentsOfEntireFile))].
	localColorTable _ nil.
	forms _ OrderedCollection new.
	offsets _ OrderedCollection new.
	delays _ OrderedCollection new.
	comments _ OrderedCollection new.
	self readHeader.
	[(body _ self readBody) == nil]
		whileFalse: [colorTable _ localColorTable
						ifNil: [colorPalette].
			transparentIndex
				ifNotNil: [transparentIndex + 1 > colorTable size
						ifTrue: [colorTable _ colorTable forceTo: transparentIndex + 1 paddingWith: Color white].
					colorTable at: transparentIndex + 1 put: Color transparent].
			body colors: colorTable.
			forms add: body.
			offsets add: offset.
			delays add: delay].
	^ forms! !

